/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalControl.commandManager;

import java.awt.Color;
import java.text.DecimalFormat;
import phalgui.Node.Stats.MyColors;

/**
 *
 * @author Usuario
 */
public class ObjectInfo {

    public String name;
    public Integer tstamp,obj_id, status, period;
    public Integer end_usec, max_usec,cpu_usec;
    public Integer pe_id;
    static final int NUM_FIELDS = 13;
    public itf[] itfs;
    public Double C;
    public String exeName;
    private Integer nvcs;
    public Integer core_id;
    private Double cpu_var;
    public  Integer mean_mac;
    public  Integer max_mac;
    public Integer pecore_idx;
    public Integer nof_rtfaults;

    public ObjectInfo() {
        itfs = new itf[0];
        this.name = new String();
        this.obj_id = new Integer(0);
        this.status = new Integer(0);
        this.nvcs = new Integer(0);
        this.cpu_usec = new Integer(0);
        this.end_usec = new Integer(0);
        this.period = new Integer(0);
        this.tstamp = new Integer(0);
        this.pe_id = new Integer(0);
        this.cpu_var = new Double(0);
        this.mean_mac = new Integer(0);
        this.max_mac = new Integer(0);
    }

    public ObjectInfo(String name, Integer obj_id, Integer status, Integer tstamp, Integer period, 
            Integer nvcs, Integer end_usec, Integer cpu_usec, Integer max_usec, Double cpu_var,
            Integer mean_mac, Integer max_mac, Integer pe_id, Integer core_id, Integer nof_rtfaults) {
        this();
        this.name = name;
        this.obj_id = obj_id;
        this.status = status;
        this.nvcs = nvcs;
        this.end_usec = end_usec;
        this.cpu_usec = cpu_usec;
        this.max_usec = max_usec;
        this.cpu_var = cpu_var;
        this.period = period;
        this.tstamp = tstamp;
        this.pe_id = pe_id;
        this.core_id = core_id;
        this.mean_mac = mean_mac;
        this.max_mac = max_mac;
        this.nof_rtfaults = nof_rtfaults;
    }


    public String toString() {
        return name;
    }

    public String getPEString() {
        return pe_id.toString() + ":" + core_id.toString();
    }

    public String[] toStrings() {
        String[] names = new String[NUM_FIELDS];
        DecimalFormat df = new DecimalFormat("00.00");

        names[0] = getPEString();
        names[1] = name;
        names[2] = tstamp.toString();
        names[3] = period.toString();
        names[4] = end_usec.toString();
        names[5] = cpu_usec.toString();
        names[6] = cpu_var.toString();
        names[7] = max_usec.toString();
        names[8] = mean_mac.toString();
        names[9] = max_mac.toString();
        names[10] = df.format(((Double) ((cpu_usec.doubleValue())*100/period.doubleValue())));
        names[11] = df.format(((Double) ((max_usec.doubleValue())*100/period.doubleValue())));
        names[12] = nof_rtfaults.toString();

        return names;
    }

    static public String[] listColumns() {
        String[] names = new String[NUM_FIELDS];

        names[0] = "PE Id";
        names[1] = "Object name";
        names[2] = "Tstamp";
        names[3] = "Period (us)";
        names[4] = "Relinquish (0)";
        names[5] = "MEAN CPU (us)";
        names[6] = "VAR CPU (us)";
        names[7] = "MAX CPU (us)";
        names[8] = "MEAN CPU (MAC)";
        names[9] = "MAX CPU (MAC)";
        names[10] = "MEAN CPU (%)";
        names[11] = "MAX CPU (%)";
        names[12] = "NOF RTFAULTS";
        return names;
    }


    public void createXitfs(int num) {
        itfs = new itf[num];
        for (int i=0;i<num;i++) {
            itfs[i] = new itf();
        }
    }

    public int getCPUusec() {
        return cpu_usec;
    }

    public float getCPUusage() {
        return (float) ((float) getCPUusec() / period);
    }

    Color colors[] = {Color.WHITE,Color.blue,Color.orange};


    public Color getPECoreColor() {
        return colors[pecore_idx%3];
    }


    public itf additf() {
        if (itfs ==null) {
            itf i = new itf();
            itfs = new itf[] {i};
            return i;
        }
        itf[] nitfs = new itf[itfs.length + 1];
        for (int i=0;i<itfs.length;i++) {
            nitfs[i] = itfs[i];
        }
        itfs = nitfs;
        itfs[itfs.length-1] = new itf();
        return itfs[itfs.length-1];
    }

/*
    public void addInputItf(ExecInfo remoteExec, itf remoteItf) {
        itfs = new itf[itfs.length+1];
        itfs[itfs.length-1] = new itf();
        itfs[itfs.length-1].mode = 1;
        itfs[itfs.length-1].remoteItf = remoteItf;
        itfs[itfs.length-1].remoteExec = remoteExec;
        remoteItf.remoteItf = itfs[itfs.length-1];
        remoteItf.remoteExec = this;
    }
*/
    public enum itfMode {
        IN(1),OUT(2),INOUT(3);
        public int num;
        itfMode(int num) {
            this.num=num;
        }
    }

    public class itf {
        public String remoteName;
        public String remoteObjectName;
        public String name;
        public Integer mode;
        public Integer delay,xitf_id,fifo_usage;
        public Double BW, totalBW;
        public ObjectInfo remoteExec;
        public itf remoteItf;
        public int order;

        public String toString() {
            return name;
        }

        public boolean isReadOnly() {
            return mode == itfMode.IN.num;
        }
        public boolean isWriteOnly() {
            return mode == itfMode.OUT.num;
        }
    }
}
