/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalControl.commandManager.Remote;

import java.io.DataInputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.Exception;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.logging.Level;
import java.util.logging.Logger;
import phalControl.commandManager.commandManager.ErrorConnectingException;

/**
 *
 * @author Usuario
 */
public class RemoteSocket {

    private String addr = null;
    private int port;
    private Socket conn = null;
    private PrintWriter out = null;
    private DataInputStream in = null;
    private boolean isconnected = false;

    @Override
    public String toString() {
        return addr;
    }
    public RemoteSocket(String addr, int port)  {
        this.addr = addr;
        this.port = port;
    }

    public boolean isConnected() {
        return isconnected;
    }
    
    public void Connect() throws UnknownHostException, SocketErrorException {
        try {
            conn = new Socket(addr, port);
            out = new PrintWriter(conn.getOutputStream(), true);
            in = new DataInputStream(conn.getInputStream());
            isconnected = true;
        } catch (IOException ex) {
            Logger.getLogger(RemoteSocket.class.getName()).log(Level.SEVERE, null, ex);
            throw new SocketErrorException("Error in socket: " + ex.getMessage());
        }
    }
    
    public void Disconnect() throws SocketErrorException {
        if (in==null || out==null) {
            throw new SocketErrorException("Error in socket: Not connected.");
        }
        try {
            in.close();
            out.close();
            conn.close();
            isconnected = false;
        } catch (IOException ex) {
            Logger.getLogger(RemoteSocket.class.getName()).log(Level.SEVERE, null, ex);
            throw new SocketErrorException("Error in socket: " + ex.getMessage());
        }
    }

    public void WriteString(String s) throws SocketErrorException{
         if (in==null || out==null) {
            throw new SocketErrorException("Error in socket: Not connected.");
        }
        s = s.replaceAll("\\n", "");
        s = s.replaceAll("\\r", "");
        out.println(s);
    }

    @SuppressWarnings("empty-statement")
    public String ReadString() throws SocketErrorException {
        if (in == null || out == null) {
            throw new SocketErrorException("Error in socket: Not connected.");
        }
        try {
            int size = in.readInt(),n=0,r;
            if (size == 0) {
                return new String();
            }
            byte[] b = new byte[size];
            
            do {
                r=in.read(b,n,size-n);
                n+=r;
            } while(r>=0 && n<size);
            if (n==size) {
                return new String(b, 0, n);
            } else {
                return new String();
            }
        } catch (IOException ex) {
            Logger.getLogger(RemoteSocket.class.getName()).log(Level.SEVERE, null, ex);
            throw new SocketErrorException("Error in socket: " + ex.getMessage());
        }
    }

    public int ReadCmd() throws SocketErrorException {
        if (in == null || out == null) {
            throw new SocketErrorException("Error in socket: Not connected.");
        }
        try {
            return in.readInt();
        } catch (IOException ex) {
            Logger.getLogger(RemoteSocket.class.getName()).log(Level.SEVERE, null, ex);
            throw new SocketErrorException("Error in socket: " + ex.getMessage());
        }
    }

    class SocketErrorException extends Exception {
        private String desc;
        public SocketErrorException(String desc) {
            this.desc=desc;
        }
        @Override
        public String getMessage() {
            return desc;
        }
    }
}
