/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalControl.commandManager;

import phalControl.WaveformControl;
import phalgui.Utils.Arrows.ValueStamp;


/**
 *
 * @author ismael
 */
public abstract class commandManager {

    String name;
    public commandManager(String platformName) {
        this.name=platformName;
    }


    @Override
    public String toString() {
        return this.name;
    }


    public abstract ProcInfo[] listProcessors() throws ErrorInCommandException;

    public abstract void loadWaveform(String waveform) throws ErrorInCommandException;
    public abstract void setWaveformStatus(String waveform, WaveformControl.Status status) throws ErrorInCommandException;
    
    public abstract ObjectInfo[] getExecInfo(String waveform, String objname) throws ErrorInCommandException;
    public abstract WaveformInfo[] getWaveformsInfo() throws ErrorInCommandException;

    public abstract StatInfo[] getStatsInfo(String waveform, String objname) throws ErrorInCommandException;
    public abstract ValueStamp[] getStatValue(String waveform, String objname, String statname) throws ErrorInCommandException;
    public abstract ValueStamp[] getStatValue(String waveform, String object, String name, int window) throws ErrorInCommandException;;
    public abstract void setStatValue(String waveform, String objname, String statname, String value) throws ErrorInCommandException;
    public abstract void startstopStatReport(String waveform, String objname, String stat, boolean start, int window, int period) throws ErrorInCommandException;

    public abstract boolean isConnected();
    public abstract void Connect() throws ErrorConnectingException;
    public abstract void Disconnect();

    public class ErrorConnectingException extends Exception {
        private String desc;
        public ErrorConnectingException(String desc) {
            this.desc=desc;
        }
        @Override
        public String getMessage() {
            return "Can't connect to platform: " + desc;
        }
    }

    public class ErrorInCommandException extends Exception {
        private String desc;
        public ErrorInCommandException(String desc) {
            this.desc=desc;
        }
        @Override
        public String getMessage() {
            return "Error sending command: " + desc;
        }
    }
}
