/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalgui.Control;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import phalgui.PhalguiView;

/**
 *
 * @author ismael
 */
public class StatusBar {

    enum State{
        CONNECTED("Connected.",new ImageIcon(PhalguiView.class.getResource("resources/connected.gif"))),
        DISCONNECTED("Disconnected",new ImageIcon(PhalguiView.class.getResource("resources/disconnected.gif")));
        String text;
        ImageIcon icon;
        State(String text, ImageIcon icon) {
            this.text=text;
            this.icon=icon;
        }
    };

    State curState;
    private JLabel TextLabel;
    private JLabel IconLabel;

    public StatusBar(JLabel Icon, JLabel text) {
        this.IconLabel=Icon;
        this.TextLabel=text;
        setState(State.DISCONNECTED);
    }

    void reset() {
        setState(curState);
    }

    void show(String string) {
        setText(string);
    }

    class ConnectingThread extends Thread {
        int counter;
        boolean run;
        String name;
        ConnectingThread(String name) {
            counter=0;
            run=true;
            this.name=name;
        }
        @Override
        public void run() {
            while(run) {
                setText("Connecting to " + name + "... (" + counter + " sec.)");
                try {
                    sleep(1000);
                    counter++;
                } catch (InterruptedException ex) {
                    run=false;
                }
            }
        }
    }
    ConnectingThread connecting=null;
    void setConnecting(String name) {
        connecting = new ConnectingThread(name);
        new Thread(connecting).start();
    }

    void setText(String text) {
        this.TextLabel.setText(text);
    }
    void setIcon(Icon icon) {
        this.IconLabel.setIcon(icon);
    }

    void setState(State state) {
        this.setText(state.text);
        this.setIcon(state.icon);
        this.curState=state;
    }

    void setConnected(String name) {
        if (connecting != null) {
            connecting.run=false;
            connecting=null;
        }
        setState(State.CONNECTED);
    }

    void setDisconnected() {
        if (connecting != null) {
            connecting.run=false;
            connecting=null;
        }
        setState(State.DISCONNECTED);
    }
}
