/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalgui.Node.Executable;
import java.io.File;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.event.TreeSelectionEvent;
import phalControl.PlatformControl.WaveformNotFoundException;
import phalControl.StatControl;
import phalControl.commandManager.commandManager.ErrorInCommandException;
import phalgui.Control.MainControl;
import phalgui.Control.MainControl.PlatformNotConnected;
import phalControl.commandManager.StatInfo;
import phalgui.Node.NodeObject;
import phalgui.Node.Parameters.WaveformParameters;
import phalgui.Node.Repositories.RepositoryObject.FileType;
import phalgui.Node.Repositories.StatsRepository;
import phalgui.Node.Stats.StatNode;
import phalgui.Node.Waveform.WaveformEntry;
import phalgui.Node.Log.LogEntry;
import phalgui.PhalguiView;
import phalgui.Tree.TreeMenuItem;
import phalgui.Tree.TreePopup;

/**
 *
 * @author Usuario
 */
public class ExecutableEntry extends NodeObject {
    private MainControl main;
    private WaveformEntry waveform;
    private String base_path,name;
    private StatsRepository statrepos;
    private WaveformParameters waveformParameters;
    private LogEntry logEntry;
    private StatNode execStat;

    public ExecutableEntry(MainControl main,
            String name, String base_path, WaveformEntry waveform) {
        this(main,name,base_path, waveform, null);
    }
    public ExecutableEntry(MainControl main,
            String name, String base_path, WaveformEntry waveform, ImageIcon icon) {
        super(name, icon);
        this.name = name;
        this.main = main;
        this.base_path = base_path;
        this.waveform = waveform;
        setPopup(new TreePopup(buildMenu()));

        File file;
        file = new File(base_path + File.separator + FileType.PARAMETERS.subdir + File.separator + waveform.toString() + File.separator + toString()+ FileType.PARAMETERS.Filter);
        if (file.exists()) {
            try {
                waveformParameters = new WaveformParameters(main, "Parameters", file, FileType.PARAMETERS.getIcon());
                add(waveformParameters);
                waveformParameters.Refresh();
            } catch (Exception ex) {
                System.out.println("Error opening parameters: " + ex.getMessage());
            }
        }
        file = new File(base_path + File.separator + FileType.LOG.subdir + File.separator + waveform.toString() + File.separator + toString() + FileType.LOG.Filter);
        if (file.exists()) {
            try {
                logEntry = new LogEntry(main, "Log", file, FileType.LOG.getIcon());
                add(logEntry);
            } catch (Exception ex) {
                System.out.println("Error opening log: " + ex.getMessage());
            }
        }
        statrepos = new StatsRepository(main, FileType.STATS.Name, waveform, toString(), FileType.STATS.getIcon());
        add(statrepos);
        addExecStat();
    }

    @Override
    public String toString() {
        return name;
    }

    public TreeMenuItem[] buildMenu() {
        TreeMenuItem items[] = new TreeMenuItem[1];
        items[0] = new TreeMenuItem("Refresh") {
            public void action() { Refresh(); }
            public boolean actionEnabled() { return true; }
        };
        return items;
    }

    @Override
    public void Refresh() {
        addExecStat();
        super.Refresh();
    }

    public void Selected(TreeSelectionEvent e) {
        waveform.Selected(e);
    }

    private void addExecStat() {
        /*
        if (execStat != null) {
            return;
//            this.remove(execStat);
        }
        NodeObject cpu = new NodeObject("CPU",new ImageIcon(PhalguiView.class.getResource("resources/information24.gif"))) {};
        add(cpu);
        try {
            if (main.getPlatform().isWaveformLoaded(waveform.toString())) {
                execStat = new StatNode(main,
                        main.getPlatform().getWaveform(waveform.toString()).getStatControl(toString(), "CPU_USAGE"),
                        waveform);
                cpu.add(execStat);
                cpu.add(new StatNode(main,
                        main.getPlatform().getWaveform(waveform.toString()).getStatControl(toString(), "CPU_START"),
                        waveform));
                cpu.add(new StatNode(main,
                        main.getPlatform().getWaveform(waveform.toString()).getStatControl(toString(), "CPU_END"),
                        waveform));
            }
        } catch (ErrorInCommandException ex) {
            Logger.getLogger(ExecutableEntry.class.getName()).log(Level.SEVERE, null, ex);
        } catch (WaveformNotFoundException ex) {
            Logger.getLogger(ExecutableEntry.class.getName()).log(Level.SEVERE, null, ex);
        } catch (PlatformNotConnected ex) {}
         */
    }

}
