/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalgui.Node.Log;
import java.awt.datatransfer.Transferable;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import phalgui.Control.MainControl;
import phalgui.Node.NodeObject;
import phalgui.Tree.TreeMenuItem;
import phalgui.Tree.TreePopup;
import phalgui.Utils.JTabbedPaneWithIcon;

/**
 *
 * @author Usuario
 */
public class LogEntry extends NodeObject {

    File file;
    String name;
    private MainControl main;

    public LogEntry(MainControl main,
            String name, File file) throws Exception {
        this(main, name, file, null);
    }

    public LogEntry(MainControl main,
            String name, File file, ImageIcon icon) throws Exception {
        super(name, icon);
        this.main = main;
        this.name = name;

        if (file == null) {
            throw new Exception("Error no file parameter:");
        }
        this.file = file;

        setPopup(new TreePopup(buildMenu()));
    }

    public TreeMenuItem[] buildMenu() {
        TreeMenuItem items[] = new TreeMenuItem[1];
        items[0] = new TreeMenuItem("View Log") {
            public void action() {View();}
            public boolean actionEnabled() { return true; }
        };
        return items;
    }


    @Override
    public void DoubleClick(MouseEvent evt) {
        View();
    }

 
    @Override
    public Transferable createTransferable(JComponent c) {
        return (Transferable) getViewer();
    }
     

    LogView log_viewer = null;
    

    public LogView getViewer() {
        if (log_viewer != null) {
        	log_viewer.stop();
	        try {
	            log_viewer.startThread();
	        } catch (FileNotFoundException ex) {
	            Logger.getLogger(LogEntry.class.getName()).log(Level.SEVERE, null, ex);
	            return null;
	        }
            return log_viewer;
    	}
        try {
            log_viewer = new LogView(file.getName(), file.getAbsolutePath());
        } catch (FileNotFoundException ex) {
            Logger.getLogger(LogEntry.class.getName()).log(Level.SEVERE, null, ex);
            return null;
        }
        return log_viewer;
    }
    private void View() {
        if (!file.exists()) {
            System.out.println("Error file " + file.getName() + " does not exists");
        }
        log_viewer = getViewer();
        if (!main.getTabPane().hasComponent(log_viewer)) {
            main.getTabPane().addTab("Log: " + file.getName().substring(0,file.getName().indexOf(".log")), log_viewer, this);
        }
        main.getTabPane().setSelectedComponent(log_viewer);

    }

    @Override
    public void Refresh() {}

    @Override
    public boolean Close() {
        log_viewer.stop();
        return true;
    }


}
