/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * MultiPanel.java
 *
 * Created on 02-dic-2008, 17:11:48
 */
package phalgui.Node.MultiPanel;

import java.awt.Component;
import java.awt.Rectangle;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Vector;
import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import phalgui.Node.NodeObject;
import phalgui.Utils.JTabbedPaneWithIcon;
import phalgui.Utils.DnD.DropablePanel;
import phalgui.Utils.DnD.TransfResizePanel;

/**
 *
 * @author Usuario
 */
public class MultiPanelView extends javax.swing.JPanel {

    //PanelTable table;
    JPanel droppanel;
    private JTabbedPaneWithIcon panel;
    private Rectangle oldRect;
    private Rectangle newRect;
    private MultiPanelNode panelNode;


    public MultiPanelView(final MultiPanelNode panelNode, JTabbedPaneWithIcon panel) {
        initComponents();
        this.panelNode = panelNode;
        droppanel = new DropablePanel(TransfResizePanel.PANEL) {

            @Override
            public void dropObject(final Object object, DropTargetDropEvent dtde) {
                final TransfResizePanel panel;
                if (object instanceof TransfResizePanel) {
                    panel = (TransfResizePanel) object;
                } else {
                    System.out.println("Invalid drop object");
                    return;
                }
                addPanel(panel, new Rectangle(dtde.getLocation().x, dtde.getLocation().y, panel.getPreferredSize().width,200));
            }
        };
        jScrollPane1.setViewportView(droppanel);
        this.panel = panel;
        droppanel.setSize(new java.awt.Dimension(1000, 700));
        droppanel.setLayout(null);

        oldRect = droppanel.getBounds();

        droppanel.setPreferredSize(new java.awt.Dimension(500, 500));
        /*droppanel.addComponentListener(new java.awt.event.ComponentAdapter() {
            @Override
            public void componentResized(java.awt.event.ComponentEvent evt) {
                if (oldRect.width == 0 && oldRect.height == 0) {
                    oldRect = droppanel.getBounds();
                    return;
                }
                newRect = droppanel.getBounds();
                if (!newRect.equals(oldRect)) {  // check if component is resized
                    float factorX = (float) newRect.width / (float) oldRect.width;
                    float factorY = (float) newRect.height / (float) oldRect.height;
                    Component[] components = droppanel.getComponents();

                    for (int i = 0; i < components.length; i++) {
                        components[i].setBounds((int) ((float) components[i].getX() * factorX),
                                (int) ((float) components[i].getY() * factorY), (int) ((float) components[i].getWidth() * factorX),
                                (int) ((float) components[i].getHeight() * factorY));
                    }
                }
                droppanel.setPreferredSize(droppanel.getSize());
                droppanel.validate();
                oldRect = newRect;
                droppanel.validate();
                droppanel.repaint();
            }
        });*/
    }

    @Override
    public int getHeight() {
        if (panel != null) {
            return panel.getHeight();
        } else {
            return this.getPreferredSize().height;
        }
    }

    TransfResizePanel[] getPanels() {
        Component[] c = droppanel.getComponents();
        Vector v = new Vector<TransfResizePanel>();
        for (int i=0;i<c.length;i++) {
            if (c[i] instanceof TransfResizePanel) {
                v.add(c[i]);
            }
        }
        return (TransfResizePanel[]) v.toArray(new TransfResizePanel[v.size()]);
    }

    public void addPanel(TransfResizePanel panel, Rectangle bounds) {
        droppanel.add(panel);
        //panel.setBorder(BorderFactory.createTitledBorder("Displaying: " + panel.toString()));
        if (bounds != null)
            panel.setBounds(bounds);
        droppanel.add(panel);
        panel.setPanel(droppanel);
        panelNode.addPanel(panel);
        droppanel.validate();
        droppanel.repaint();

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();

        setName("Form"); // NOI18N
        setLayout(new java.awt.GridLayout(1, 0));

        jScrollPane1.setName("jScrollPane1"); // NOI18N
        add(jScrollPane1);
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
}