/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalgui.Node.Parameters;

import java.awt.event.MouseEvent;
import java.io.File;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextPane;
import phalgui.Control.MainControl;
import phalgui.Node.NodeObject;
import phalgui.Tree.TreeMenuItem;
import phalgui.Tree.TreePopup;
import phalgui.Utils.ReadWriteTextFile;

/**
 *
 * @author root
 */
public class WaveformParameters extends NodeObject  {

    File file;
    private MainControl main;
    
    public WaveformParameters(MainControl main,
            String name, File file) throws Exception {
        this(main, name, file, null);
    }
    
    public WaveformParameters(MainControl main,
            String name, File file, ImageIcon icon) throws Exception {
        super(name, icon);
        this.main = main;
        if (file == null) {
            throw new Exception("Error with parameter file");
        } 
        this.file = file;

        setPopup(new TreePopup(buildMenu()));
    }

     public TreeMenuItem[] buildMenu() {
        TreeMenuItem items[] = new TreeMenuItem[3];
        items[0] = new TreeMenuItem("Edit") {
            public void action() { Edit(); }
            public boolean actionEnabled() { return isEditEnabled(); }
        };
        items[1] = new TreeMenuItem("Remove") {
            public void action() { Remove(); }
            public boolean actionEnabled() { return true; }
        };
        items[2] = new TreeMenuItem("Rename") {
            public void action() { Rename(); }
            public boolean actionEnabled() { return true; }
        };
        return items;
    }

    @Override
   public void DoubleClick(MouseEvent evt) {
        Edit();
    }

   public boolean isEditEnabled() {
        if (scroll != null) 
            return !scroll.isShowing();
        return true;
    }
   private javax.swing.JScrollPane scroll;
   private javax.swing.JTextArea text;
   
    public void Edit() {
        if (!file.exists()) {
            try {
                file.createNewFile();
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(main.getFrame(), "Error creating file: " + ex.getMessage(), "Error creating waveform", JOptionPane.ERROR_MESSAGE);
            }
        }
        if (scroll == null) {
        	scroll  = new JScrollPane();
        	text = new JTextArea();
        	scroll.setViewportView(text);
        	text.setText(ReadWriteTextFile.getContents(file));
        	text.setAutoscrolls(true);
            scroll.setWheelScrollingEnabled(true);
        }
        if (!main.getTabPane().hasComponent(scroll)) {
            main.getTabPane().addTab("Waveform Parameters " + toString(), scroll, this);
        }
        main.getTabPane().setSelectedComponent(scroll);
        
    }

    @Override
    public void Save() { 
        ReadWriteTextFile.setContents(file, text.getText());    
    }

    @Override
    public boolean isSaved() {
        return text.getText().equals(ReadWriteTextFile.getContents(file));
    }

    @Override
    public void Remove() {
        if (JOptionPane.showConfirmDialog(main.getFrame(), "Are you sure you want to delete waveform " + toString() +  "?")
                == JOptionPane.YES_OPTION) {
            if (!file.delete()) {
                JOptionPane.showMessageDialog(main.getFrame(), "Could not delete file");
            } else {
                super.Remove();
            }
        }
    }

    @Override
    public void Refresh() {}
 
}
