/*
 * PlatformEdit.java
 *
 * Created on 20 de octubre de 2008, 15:25
 */
package phalgui.Node.Platform;

import java.io.File;
import javax.swing.JFileChooser;
import phalgui.Control.MainControl;

/**
 *
 * @author  root
 */
public class PlatformEdit extends javax.swing.JPanel {

    PlatformEntry plat;
    String my_loc, my_name;
    
    /** Creates new form PlatformEdit */
    public PlatformEdit(PlatformEntry plt) {
        initComponents();
        plat = plt;
        my_name = plt.toString();
        my_loc = plt.addr;

        name_field.setText(my_name);
        type_local.setSelected(plt.is_local);
        type_localItemStateChanged(null);
        save.setEnabled(false);
     
        launch.setSelected(plt.launch);
        workpath.setText(plt.workPath);

        restartCmd.setText(plt.restartCommand);
        
        autoconnect.setEnabled(!plt.isAnyPlatformAuto());
        autoconnect.setSelected(plt.isAutoConnect());
    }


    String getPltLoc() {
        if (type_local.isSelected()) {
            return address_field.getText();
        } else {
            if (address_field.getText().length() > 0) {
                return address_field.getText() + ":" + port_field.getText();    
            } else {
                return "";
            }
        }
    }

    String getPltName() {
        return name_field.getText();
    }

    boolean getPltisLocal() {
        return type_local.isSelected();
    }
    
    boolean getLaunch() {
        return launch.isSelected();
    }

    boolean getAutoConnect() {
        return autoconnect.isSelected();
    }

    String getrestartCmd() {
        return restartCmd.getText();
    }

    String getworkPath() {
        return workpath.getText();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        address_label = new javax.swing.JLabel();
        address_field = new javax.swing.JTextField();
        port_field = new javax.swing.JTextField();
        port_label = new javax.swing.JLabel();
        type_local = new javax.swing.JRadioButton();
        type_remote = new javax.swing.JRadioButton();
        jLabel3 = new javax.swing.JLabel();
        name_field = new javax.swing.JTextField();
        save = new javax.swing.JButton();
        launch = new javax.swing.JCheckBox();
        workpath = new javax.swing.JTextField();
        browse = new javax.swing.JButton();
        worklabel = new javax.swing.JLabel();
        autoconnect = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        worklabel1 = new javax.swing.JLabel();
        restartCmd = new javax.swing.JTextField();

        setName("Form"); // NOI18N
        addInputMethodListener(new java.awt.event.InputMethodListener() {
            public void caretPositionChanged(java.awt.event.InputMethodEvent evt) {
            }
            public void inputMethodTextChanged(java.awt.event.InputMethodEvent evt) {
                formInputMethodTextChanged(evt);
            }
        });

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(phalgui.PhalguiApp.class).getContext().getResourceMap(PlatformEdit.class);
        address_label.setText(resourceMap.getString("address_label.text")); // NOI18N
        address_label.setName("address_label"); // NOI18N

        address_field.setText(resourceMap.getString("address_field.text")); // NOI18N
        address_field.setName("address_field"); // NOI18N
        address_field.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                address_fieldActionPerformed(evt);
            }
        });
        address_field.addInputMethodListener(new java.awt.event.InputMethodListener() {
            public void caretPositionChanged(java.awt.event.InputMethodEvent evt) {
            }
            public void inputMethodTextChanged(java.awt.event.InputMethodEvent evt) {
                address_fieldInputMethodTextChanged(evt);
            }
        });
        address_field.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                address_fieldKeyPressed(evt);
            }
        });

        port_field.setName("port_field"); // NOI18N
        port_field.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                port_fieldActionPerformed(evt);
            }
        });
        port_field.addInputMethodListener(new java.awt.event.InputMethodListener() {
            public void caretPositionChanged(java.awt.event.InputMethodEvent evt) {
            }
            public void inputMethodTextChanged(java.awt.event.InputMethodEvent evt) {
                port_fieldInputMethodTextChanged(evt);
            }
        });
        port_field.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                port_fieldKeyPressed(evt);
            }
        });

        port_label.setText(resourceMap.getString("port_label.text")); // NOI18N
        port_label.setName("port_label"); // NOI18N

        buttonGroup1.add(type_local);
        type_local.setText(resourceMap.getString("type_local.text")); // NOI18N
        type_local.setName("type_local"); // NOI18N
        type_local.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                type_localItemStateChanged(evt);
            }
        });
        type_local.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                type_localActionPerformed(evt);
            }
        });

        buttonGroup1.add(type_remote);
        type_remote.setText(resourceMap.getString("type_remote.text")); // NOI18N
        type_remote.setName("type_remote"); // NOI18N
        type_remote.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                type_remoteActionPerformed(evt);
            }
        });

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        name_field.setText(resourceMap.getString("name_field.text")); // NOI18N
        name_field.setName("name_field"); // NOI18N
        name_field.addInputMethodListener(new java.awt.event.InputMethodListener() {
            public void caretPositionChanged(java.awt.event.InputMethodEvent evt) {
            }
            public void inputMethodTextChanged(java.awt.event.InputMethodEvent evt) {
                name_fieldInputMethodTextChanged(evt);
            }
        });
        name_field.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                name_fieldKeyPressed(evt);
            }
        });

        save.setText(resourceMap.getString("save.text")); // NOI18N
        save.setEnabled(false);
        save.setName("save"); // NOI18N
        save.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                saveMouseClicked(evt);
            }
        });

        launch.setText(resourceMap.getString("launch.text")); // NOI18N
        launch.setName("launch"); // NOI18N
        launch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                launchActionPerformed(evt);
            }
        });

        workpath.setName("workpath"); // NOI18N
        workpath.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                workpathActionPerformed(evt);
            }
        });
        workpath.addInputMethodListener(new java.awt.event.InputMethodListener() {
            public void caretPositionChanged(java.awt.event.InputMethodEvent evt) {
            }
            public void inputMethodTextChanged(java.awt.event.InputMethodEvent evt) {
                workpathInputMethodTextChanged(evt);
            }
        });
        workpath.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                workpathKeyPressed(evt);
            }
        });

        browse.setText(resourceMap.getString("browse.text")); // NOI18N
        browse.setName("browse"); // NOI18N
        browse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browseActionPerformed(evt);
            }
        });

        worklabel.setText(resourceMap.getString("worklabel.text")); // NOI18N
        worklabel.setName("worklabel"); // NOI18N

        autoconnect.setText(resourceMap.getString("autoconnect.text")); // NOI18N
        autoconnect.setName("autoconnect"); // NOI18N
        autoconnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                autoconnectActionPerformed(evt);
            }
        });

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        worklabel1.setText(resourceMap.getString("worklabel1.text")); // NOI18N
        worklabel1.setName("worklabel1"); // NOI18N

        restartCmd.setName("restartCmd"); // NOI18N
        restartCmd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                restartCmdActionPerformed(evt);
            }
        });
        restartCmd.addInputMethodListener(new java.awt.event.InputMethodListener() {
            public void caretPositionChanged(java.awt.event.InputMethodEvent evt) {
            }
            public void inputMethodTextChanged(java.awt.event.InputMethodEvent evt) {
                restartCmdInputMethodTextChanged(evt);
            }
        });
        restartCmd.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                restartCmdKeyPressed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(29, 29, 29)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(worklabel1)
                    .addComponent(restartCmd, javax.swing.GroupLayout.PREFERRED_SIZE, 182, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(save, javax.swing.GroupLayout.PREFERRED_SIZE, 77, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(autoconnect)
                    .addComponent(launch)
                    .addComponent(jLabel1)
                    .addComponent(jLabel3)
                    .addComponent(name_field, javax.swing.GroupLayout.PREFERRED_SIZE, 169, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(worklabel)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(workpath, javax.swing.GroupLayout.PREFERRED_SIZE, 182, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(browse))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(address_label)
                            .addComponent(address_field, javax.swing.GroupLayout.PREFERRED_SIZE, 165, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(2, 2, 2)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(port_field, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(port_label)))
                    .addComponent(type_local)
                    .addComponent(type_remote))
                .addContainerGap(82, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(name_field, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(25, 25, 25)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(type_local)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(type_remote)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(address_label)
                    .addComponent(port_label))
                .addGap(7, 7, 7)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(address_field, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(port_field, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(worklabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(workpath, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(browse))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(worklabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(restartCmd, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(7, 7, 7)
                .addComponent(launch)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(autoconnect)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(save)
                .addGap(0, 0, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

private void type_localItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_type_localItemStateChanged

    if (type_local.isSelected()) {
        type_remote.setSelected(false);
        address_label.setText("");
        
        address_field.setVisible(false);
        port_label.setVisible(false);
        port_field.setVisible(false);
        launch.setVisible(true);
        workpath.setVisible(true);
        browse.setVisible(true);
        worklabel.setText("Daemons repository path:");
    } else {
        type_remote.setSelected(true);
        address_label.setText("IP Address:");
        if (!plat.is_local && my_loc.contains((":"))) {
            address_field.setText(my_loc.substring(0, my_loc.indexOf(":")));
            port_field.setText(my_loc.substring(my_loc.indexOf(":")+1));
        } else {
            address_field.setText("");
            port_field.setText("");
        }
        address_field.setVisible(true);
        port_label.setVisible(true);
        port_field.setVisible(true);
        launch.setVisible(false);
        worklabel.setText("Output log path:");
    }
    
    save.setEnabled(true);

}//GEN-LAST:event_type_localItemStateChanged


private void saveMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_saveMouseClicked
    plat.Save();//GEN-LAST:event_saveMouseClicked
    save.setEnabled(false);
}                                 

private void formInputMethodTextChanged(java.awt.event.InputMethodEvent evt) {//GEN-FIRST:event_formInputMethodTextChanged
}//GEN-LAST:event_formInputMethodTextChanged

private void address_fieldInputMethodTextChanged(java.awt.event.InputMethodEvent evt) {//GEN-FIRST:event_address_fieldInputMethodTextChanged
}//GEN-LAST:event_address_fieldInputMethodTextChanged

private void port_fieldInputMethodTextChanged(java.awt.event.InputMethodEvent evt) {//GEN-FIRST:event_port_fieldInputMethodTextChanged
}//GEN-LAST:event_port_fieldInputMethodTextChanged

private void address_fieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_address_fieldActionPerformed
}//GEN-LAST:event_address_fieldActionPerformed

private void port_fieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_port_fieldActionPerformed
}//GEN-LAST:event_port_fieldActionPerformed

private void type_localActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_type_localActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_type_localActionPerformed

private void name_fieldInputMethodTextChanged(java.awt.event.InputMethodEvent evt) {//GEN-FIRST:event_name_fieldInputMethodTextChanged
// TODO add your handling code here:
}//GEN-LAST:event_name_fieldInputMethodTextChanged

private void name_fieldKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_name_fieldKeyPressed
    save.setEnabled(true);
}//GEN-LAST:event_name_fieldKeyPressed

private void address_fieldKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_address_fieldKeyPressed
    save.setEnabled(true);
}//GEN-LAST:event_address_fieldKeyPressed

private void port_fieldKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_port_fieldKeyPressed
    save.setEnabled(true);
}//GEN-LAST:event_port_fieldKeyPressed

private void type_remoteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_type_remoteActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_type_remoteActionPerformed

private void launchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_launchActionPerformed
    save.setEnabled(true);
    
}//GEN-LAST:event_launchActionPerformed

private void workpathActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_workpathActionPerformed
    save.setEnabled(true);
}//GEN-LAST:event_workpathActionPerformed

private void workpathInputMethodTextChanged(java.awt.event.InputMethodEvent evt) {//GEN-FIRST:event_workpathInputMethodTextChanged
// TODO add your handling code here:
}//GEN-LAST:event_workpathInputMethodTextChanged

private void workpathKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_workpathKeyPressed
save.setEnabled(true);
}//GEN-LAST:event_workpathKeyPressed

private void browseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browseActionPerformed
     final JFileChooser fc = new JFileChooser();

     if (getPltisLocal()) {
        fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
     }
    if (workpath.getText().length() > 0) {
        fc.setSelectedFile(new File(workpath.getText()));
    }
    if (fc.showOpenDialog(this.getParent()) == JFileChooser.APPROVE_OPTION) {
        workpath.setText(fc.getSelectedFile().toString());
        save.setEnabled(true);
    }
}//GEN-LAST:event_browseActionPerformed

private void autoconnectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_autoconnectActionPerformed
    save.setEnabled(true);
}//GEN-LAST:event_autoconnectActionPerformed

private void restartCmdActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_restartCmdActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_restartCmdActionPerformed

private void restartCmdInputMethodTextChanged(java.awt.event.InputMethodEvent evt) {//GEN-FIRST:event_restartCmdInputMethodTextChanged
    // TODO add your handling code here:
}//GEN-LAST:event_restartCmdInputMethodTextChanged

private void restartCmdKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_restartCmdKeyPressed
    // TODO add your handling code here:
    save.setEnabled(true);
}//GEN-LAST:event_restartCmdKeyPressed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField address_field;
    private javax.swing.JLabel address_label;
    private javax.swing.JCheckBox autoconnect;
    private javax.swing.JButton browse;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JCheckBox launch;
    private javax.swing.JTextField name_field;
    private javax.swing.JTextField port_field;
    private javax.swing.JLabel port_label;
    private javax.swing.JTextField restartCmd;
    private javax.swing.JButton save;
    private javax.swing.JRadioButton type_local;
    private javax.swing.JRadioButton type_remote;
    private javax.swing.JLabel worklabel;
    private javax.swing.JLabel worklabel1;
    private javax.swing.JTextField workpath;
    // End of variables declaration//GEN-END:variables
}
