/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalgui.Node.Platform;

import java.awt.event.MouseEvent;
import java.io.IOException;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import phalControl.commandManager.ProcInfo;
import phalControl.commandManager.commandManager.ErrorInCommandException;
import phalgui.Control.MainControl;
import phalgui.Control.MainControl.PlatformNotConnected;
import phalgui.Node.NodeObject;
import phalgui.Node.Processor.ProcessorGraphic;
import phalgui.Node.Processor.ProcessorNode;
import phalgui.Node.Stats.GraphicPanel;
import phalgui.Tree.TreeMenuItem;
import phalgui.Tree.TreePopup;
import phalgui.Utils.Graphics.GraphicsPanel;

/**
 *
 * @author root
 */
public class PlatformEntry extends NodeObject   {
    
    String addr = new String();
    String workPath = new String();
    String restartCommand = new String();
    boolean is_local, launch, is_auto;
    
    private MainControl main;
    private String name;
    
    public PlatformEntry(MainControl main, String name) {
        this(main, name, null);
    }

    public PlatformEntry(MainControl main, String name, ImageIcon icon) {
        super(name, icon);
        this.name = name;
        this.main = main;
        setPopup(new TreePopup(buildMenu()));
    }

    @Override
    public String toString() {
        return name;
    }

    public boolean isAutoConnect() {
        return is_auto;
    }

    private void Connect() {
        if (is_local) {
            //main.connectLocalPlatform(name, name, workPath);
        } else {
            main.connectRemotePlatform(name, addr, workPath);
        }
    }

    private void Disconnect() {
        main.disconnectPlatform();
        /*
        if (is_local) {
            if (launch) {
                try {
                        ((LocalPlatform) controlPlatform).Kill();
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(panel.pframe, "Error killing platform:\n" + ex.getMessage(), "Platform launch", JOptionPane.ERROR_MESSAGE);
                    return;
                }
            }
        }
         */
    }

    public boolean isConnected() {
        return main.isConnected();
    }

    public void Restart() {
        new Thread(new Runnable() {

            public void run() {
                boolean wasconnected=false;

                if (isConnected()) {
                    Disconnect();
                    wasconnected=true;
                    try {
                        Thread.sleep(3000);
                    } catch (InterruptedException ex) {
                        Logger.getLogger(PlatformEntry.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
                try {
                    Process p = Runtime.getRuntime().exec(restartCommand);
                    p.waitFor();
                } catch (InterruptedException ex) {
                    Logger.getLogger(PlatformEntry.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IOException ex) {
                    Logger.getLogger(PlatformEntry.class.getName()).log(Level.SEVERE, null, ex);
                }
                if (wasconnected) {
                    try {
                        Thread.sleep(2000);
                    } catch (InterruptedException ex) {
                        Logger.getLogger(PlatformEntry.class.getName()).log(Level.SEVERE, null, ex);
                    }
                    Connect();
                }
            }
        }).start();
       
    }

    public TreeMenuItem[] buildMenu() {
        TreeMenuItem items[] = new TreeMenuItem[7];
        items[0] = new TreeMenuItem("Connect") {
            public void action() { Action(); }
            public boolean actionEnabled() { return isActionEnabled(); }
            @Override
            public String getText() { return ActionString(); }
        };
        items[1] = new TreeMenuItem("View") {
            public void action() { View(); }
            public boolean actionEnabled() { return isEditEnabled(); }
        };
        items[2] = new TreeMenuItem("Edit") {
            public void action() { Edit(); }
            public boolean actionEnabled() { return isEditEnabled(); }
        };
        items[3] = new TreeMenuItem("Remove") {
            public void action() { Remove(); }
            public boolean actionEnabled() { return true; }
        };
        items[4] = new TreeMenuItem("Rename") {
            public void action() { Rename(); }
            public boolean actionEnabled() { return isEditEnabled(); }
        };
        items[5] = new TreeMenuItem("Refresh") {
            public void action() { Refresh(); }
            public boolean actionEnabled() { return isConnected(); }
        };
        items[6] = new TreeMenuItem("Restart") {
            public void action() { Restart(); }
            public boolean actionEnabled() { return true; }
        };
        return items;
    }

    @Override
    public void DoubleClick(MouseEvent evt) {
        Edit();
    }

    public void Action() { 
        if (isConnected()) {
            Disconnect();
        } else {
            Connect();
        }
    }
    
 
    public String ActionString() {
        if (isConnected()) {
            if (launch) {
                return "Kill and disconnect";
            } else {
                return "Disconnect";
            }
        } else {
            if (launch) {
                if (workPath.length() == 0) {
                    return "<Configure work path>";
                } else {
                    return "Launch and connect";
                }
            } else {
                return "Connect";
            }
        }
    }

    public boolean isActionEnabled() {
        if (main.isConnecting())
            return false;
        else
            return true;
    }

    public boolean isEditEnabled() {
        if (plt_edit != null) {
            return !plt_edit.isShowing();            
        }
        return true;
    }

    PlatformEdit plt_edit;
        
    public void Edit() {
        if (plt_edit != null) {
            plt_edit.setEnabled(false);
            plt_edit = null;
        }
        plt_edit = new PlatformEdit(this);
        if (!main.getTabPane().hasComponent(plt_edit)) {
           main.getTabPane().addTab("Edit " + this.toString(), plt_edit, this);
        }
        main.getTabPane().setSelectedComponent(plt_edit);
    }

    PlatformView plt_view=null;

    public void View() {
        try {
            if (plt_view == null) {
                plt_view = new PlatformView(main,xyprocs);

            }
            if (!main.getTabPane().hasComponent(plt_view)) {
                main.getTabPane().addTab("Viewing " + this.toString(), plt_view, this);
            }
            main.getTabPane().setSelectedComponent(plt_view);
        } catch (ErrorInCommandException ex) {
            Logger.getLogger(PlatformEntry.class.getName()).log(Level.SEVERE, null, ex);
        } catch (PlatformNotConnected ex) {
            Logger.getLogger(PlatformEntry.class.getName()).log(Level.SEVERE, null, ex);
        }
    }


    @Override
    public void Save() {
        if (plt_edit == null)
            return;
        name = plt_edit.getPltName();
        is_local = plt_edit.getPltisLocal();
        addr = plt_edit.getPltLoc();
        launch = plt_edit.getLaunch();
        workPath = plt_edit.getworkPath();
        is_auto = plt_edit.getAutoConnect();
        restartCommand = plt_edit.getrestartCmd();
        Redraw();
    }

    @Override
    public boolean isSaved() {
        if (plt_edit == null)
            return true;
        if (!name.equals(plt_edit.getPltName())) {
            return false;
        } else if (is_local != plt_edit.getPltisLocal()) {
            return false;
        } else if (is_auto != plt_edit.getAutoConnect()) {
            return false;
        } else if (launch != plt_edit.getLaunch()) {
            return false;
        } else if (!addr.equals(plt_edit.getPltLoc())) {
            return false;
        } else if (!workPath.equals(plt_edit.getworkPath())) {
            return false;
        } else if (!restartCommand.equals(plt_edit.getrestartCmd())) {
            return false;
        }
        return true;
    }

    public boolean isAnyPlatformAuto() {
        int i;
        for (i=0;i<getParent().getChildCount();i++) {
            PlatformEntry platform = (PlatformEntry) getParent().getChildAt(i);
            if (platform.isAutoConnect() && !platform.equals(this)) {
                return true;
            }
        }
        return false;
    }

    @Override
    public boolean WriteConfig(Properties config) {
        config.setProperty("platform." + super.toString() + "." + "loc", addr);
        config.setProperty("platform." + super.toString() + "." + "islocal", is_local?"y":"n");
        config.setProperty("platform." + super.toString() + "." + "isauto", is_auto?"y":"n");
        config.setProperty("platform." + super.toString() + "." + "launch", launch?"y":"n");
        config.setProperty("platform." + super.toString() + "." + "workpath", workPath);
        config.setProperty("platform." + super.toString() + "." + "restartcmd", restartCommand);
        if (plt_view != null) {
            String s = new String();
            for (int i=0;i<plt_view.getObjects().length;i++) {
                config.setProperty("platform." + super.toString() + plt_view.getObjects()[i].toString() + ".x", String.valueOf(plt_view.getObjects()[i].getX()));
                config.setProperty("platform." + super.toString() + plt_view.getObjects()[i].toString() +".y", String.valueOf(plt_view.getObjects()[i].getY()));
                s += plt_view.getObjects()[i].toString();
                if (i<plt_view.getObjects().length-1) {
                    s+=",";
                }
            }
            config.setProperty("platform." + super.toString() + ".plt_view",s);
        }
        return true;
    }

    @Override
    public boolean ReadConfig(Properties config) {
        addr = new String(config.getProperty("platform." + super.toString() + "." + "loc"));
        workPath = new String(config.getProperty("platform." + super.toString() + "." + "workpath"));
        restartCommand = new String(config.getProperty("platform." + super.toString() + "." + "restartcmd"));
        String s = config.getProperty("platform." + super.toString() + "." + "islocal");
        if (s != null) {
            if (s.equals("y")) {
                is_local = true;
            } else {
                is_local = false;
            }            
        }
        s = config.getProperty("platform." + super.toString() + "." + "isauto");
        if (s != null) {
            if (s.equals("y") && !isAnyPlatformAuto()) {
                is_auto = true;
            } else {
                is_auto = false;
            }
        }
        if (is_local) {
            s = config.getProperty("platform." + super.toString() + "." + "launch");
            if (s != null) {
                if (s.equals("y")) {
                    launch = true;
                } else {
                    launch = false;
                }
            }
        } else {
            launch=false;
        }


        if (is_auto) {
            Connect();
        }

        String procs = config.getProperty("platform." + super.toString() + ".plt_view");
        if (procs != null) {
            String p[] = procs.split(",");
            xyprocs = new XYProcs[p.length];
            for (int i=0;i<p.length;i++) {
                xyprocs[i] = new XYProcs();
                xyprocs[i].id = Integer.valueOf(p[i]);
                xyprocs[i].x = Double.valueOf(config.getProperty("platform." + super.toString() + p[i] + ".x")).doubleValue();
                xyprocs[i].y = Double.valueOf(config.getProperty("platform." + super.toString() + p[i] + ".y")).doubleValue();
            }
        }

        return true;
    }
    
    XYProcs[] xyprocs=null;

    class XYProcs {
        double x,y;
        Integer id;
    }

    @Override
    public void Refresh() {
      
        try {
            ProcInfo[] procs = main.getPlatform().getProcessors();
            removeAllChilds();
            if (procs==null)
                return;
            for (int i=0;i<procs.length;i++) {
                ProcessorNode p = new ProcessorNode(main,procs[i]);
                add(p);
            }
        } catch (ErrorInCommandException ex) {
            Logger.getLogger(PlatformEntry.class.getName()).log(Level.SEVERE, null, ex);
        } catch (PlatformNotConnected ex) {
            Logger.getLogger(PlatformEntry.class.getName()).log(Level.SEVERE, null, ex);
        }

    }
}



