/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * PlatformView.java
 *
 * Created on 01-abr-2009, 14:11:08
 */

package phalgui.Node.Platform;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.SwingWorker;
import javax.swing.border.TitledBorder;
import phalControl.commandManager.ProcInfo;
import phalControl.commandManager.commandManager.ErrorInCommandException;
import phalgui.Control.MainControl;
import phalgui.Control.MainControl.PlatformNotConnected;
import phalgui.Node.Platform.PlatformEntry.XYProcs;
import phalgui.Node.Processor.ProcessorGraphic;
import phalgui.Node.Processor.ProcessorView;
import phalgui.Utils.Graphics.GraphicsPanel;

/**
 *
 * @author ismael
 */
public class PlatformView  extends GraphicsPanel {
    private MainControl main;
    //private GraphicsPanel plt_view;
    JPopupMenu popup;

    ProcessorView procView;
    private JComboBox selectView;
    private JCheckBox viewMoreCheckbox;
    
    PlatformView(MainControl main, XYProcs xyprocs[]) throws PlatformNotConnected, ErrorInCommandException {
        super();
        procView = new ProcessorView();
        JPanel buttonPanel = new JPanel();
        JButton refresh = new JButton ("Refresh");
        refresh.addActionListener (new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                refreshButtonActionPerformed(e);
            }
        });
        buttonPanel.add (refresh);
        buttonPanel.add(new JLabel("Select data to display:"));
        selectView = new JComboBox();
        for (int i=0;i<ProcessorGraphic.ViewInfo.values().length;i++) {
            selectView.addItem(ProcessorGraphic.ViewInfo.values()[i]);
        }
        selectView.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                selectView();
            }
        });
        selectView.setSelectedItem(ProcessorGraphic.ViewInfo.MIPS);
        buttonPanel.add(selectView);
        viewMoreCheckbox = new JCheckBox();
        viewMoreCheckbox.setText("View more info");
        viewMoreCheckbox.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                procView.setVisible(viewMoreCheckbox.isSelected());
            }
        });
        buttonPanel.add(viewMoreCheckbox);
        viewMoreCheckbox.setSelected(false);
        procView.setVisible(false);
        add(buttonPanel, BorderLayout.NORTH);

        add(procView, BorderLayout.SOUTH);
        procView.setButtonVisible(false);

        this.main = main;
        ProcInfo[] procs = main.getPlatform().getProcessors();
        ProcessorGraphic[] pg = new ProcessorGraphic[procs.length];
        for (int i = 0; i < procs.length; i++) {
            double x = 400 * ((i + 1) % 4);
            double y = 400 * (i / 4 + 1);
            if (xyprocs != null) {
                for (int j = 0; j < xyprocs.length; j++) {
                    if (procs[i].id.equals(xyprocs[j].id)) {
                        x = xyprocs[j].x;
                        y = xyprocs[j].y;
                    }
                }
            }
            pg[i] = new ProcessorGraphic(main, procs[i], x, y, procView);
            pg[0].setSelected(true);
            procView.setProcessor(procs[0]);
        }
        add(pg);
        /*
        for (int i = 0; i < pg.length; i++) {
            for (int j = 0; j < pg.length; j++) {
                if (pg[i].connectsWith(pg[j])) {
                    pg[i].connectWith(pg[j]);
                }
            }
        }
         */


        

       
    }

    private void selectView() {
        for (int i=0;i<getObjects().length;i++) {
           ((ProcessorGraphic) getObjects()[i]).selectView((ProcessorGraphic.ViewInfo) selectView.getSelectedItem());
        }
        getScene().refresh();
    }

/*
    GraphicsObject[] getObjects() {
        return plt_view.getObjects();
    }
*/

    private void refreshButtonActionPerformed(ActionEvent e) {
        // TODO add your handling code here:
        SwingWorker w = new SwingWorker<Void,Void>() {

            @Override
            protected Void doInBackground() throws Exception {
                main.getPlatform().refresh();
                return null;
            }
            @Override
            protected void done() {
                try {
                    ProcInfo[] procs = main.getPlatform().getProcessors();
                    Object[] pg = (Object[]) getObjects();
                    for (int i=0;i<procs.length;i++) {
                        boolean found=false;
                        for (int j=0;j<pg.length;j++) {
                            if (pg[j].toString().equals(String.valueOf(procs[i].id))) {
                                ((ProcessorGraphic) pg[j]).updateInfo(procs[i]);
                                found=true;
                            }
                        }
                        if (!found) {
                            ProcessorGraphic p = new ProcessorGraphic(main, procs[i],
                                    ((ProcessorGraphic) pg[pg.length-1]).getX()+400,
                                    ((ProcessorGraphic) pg[pg.length-1]).getY()+400,
                                    procView);
                            add(p);
                        }
                    }
                    for (int i = 0; i < pg.length; i++) {
                        for (int j = 0; j < pg.length; j++) {
                            if (((ProcessorGraphic) pg[i]).connectsWith(((ProcessorGraphic) pg[j]))) {
                                ((ProcessorGraphic) pg[i]).connectWith(((ProcessorGraphic) pg[j]));
                            }
                        }
                    }
                    procView.refresh();
                } catch (PlatformNotConnected ex) {
                    Logger.getLogger(PlatformView.class.getName()).log(Level.SEVERE, null, ex);
                } catch (ErrorInCommandException ex) {
                    Logger.getLogger(PlatformView.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        };
        w.execute();
    }



}
