/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalgui.Node.Processor;

import java.awt.datatransfer.Transferable;
import java.awt.event.MouseEvent;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JComponent;
import no.geosoft.cc.graphics.GObject;
import phalControl.commandManager.ProcInfo;
import phalControl.commandManager.commandManager.ErrorInCommandException;
import phalgui.Control.MainControl;
import phalgui.Control.MainControl.PlatformNotConnected;
import phalgui.Node.NodeObject;
import phalgui.Tree.TreeMenuItem;
import phalgui.Tree.TreePopup;

/**
 *
 * @author ismael
 */
public class ProcessorNode extends NodeObject  {
    ProcInfo procInfo;
    private MainControl main;
    private ProcessorView proc_view;

    public ProcessorNode(MainControl main, ProcInfo procInfo) {
        super(procInfo.name,null);
        setPopup(new TreePopup(buildMenu()));
        this.procInfo = procInfo;
        this.main = main;
    }

    @Override
    public String toString() {
        return procInfo.name;
    }

    public TreeMenuItem[] buildMenu() {
        TreeMenuItem items[] = new TreeMenuItem[1];
        items[0] = new TreeMenuItem("View Info") {
            public void action() { View(); }
            public boolean actionEnabled() { return true; }
        };
        return items;
    }

    void refresh() {
        try {
            main.getPlatform().refresh();
            ProcInfo procs[] = main.getPlatform().getProcessors();
            for (int i=0;i<procs.length;i++) {
                if (procs[i].id==procInfo.id) {
                    procInfo = procs[i];
                }
            }
         } catch (ErrorInCommandException ex) {
            Logger.getLogger(ProcessorNode.class.getName()).log(Level.SEVERE, null, ex);
        } catch (PlatformNotConnected ex) {
            Logger.getLogger(ProcessorNode.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private ProcessorView getViewer() {
        if (proc_view != null) {
            proc_view.setEnabled(false);
            proc_view = null;
        }
        proc_view = new ProcessorView(this);
        return proc_view;
    }

    private void View() {
        getViewer();
        if (!main.getTabPane().hasComponent(proc_view)) {
           main.getTabPane().addTab("Viewing " + this.toString(), proc_view, this);
        }
        main.getTabPane().setSelectedComponent(proc_view);
    }

    @Override
    public void DoubleClick(MouseEvent evt) {
        View();
    }

     @Override
    public Transferable createTransferable(JComponent c) {
        return (Transferable) getViewer();
    }

}
