/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ProcessorView.java
 *
 * Created on 16-mar-2009, 19:37:44
 */

package phalgui.Node.Processor;

import java.text.DecimalFormat;
import javax.swing.SwingWorker;
import phalControl.commandManager.ProcInfo;
import phalgui.Node.Processor.ProcessorGraphic.ViewInfo;
import phalgui.PhalguiApp;
import phalgui.Utils.DnD.TransfResizePanel;

/**
 *
 * @author ismael
 */
public class ProcessorView extends TransfResizePanel {
    private ProcessorNode procNode;
    private String procName;
    private ProcInfo procInfo;

    /** Creates new form ProcessorView */
    public ProcessorView() {
        initComponents();
    }

    public ProcessorView(String[] info) {
        this();
        procName = info[0];
        getprocNode();
        readValues();
    }

    public ProcessorView(ProcessorNode procNode) {
        this();
        this.procNode = procNode;
        this.procInfo = procNode.procInfo;
        this.procName = procNode.toString();
        readValues();
    }

    public ProcessorView(ProcInfo procInfo) {
        this();
        this.procInfo = procInfo;
        readValues();
    }

    public void setProcessor(ProcInfo procInfo) {
        this.procInfo=procInfo;
        readValues();
    }

    
    @Override
    public String toString() {
        return procName;
    }

    private void getprocNode() {
        procNode = (ProcessorNode) ((PhalguiApp) PhalguiApp.getApplication()).getMainControl().getTree().findNodeName(procName);
        procInfo = procNode.procInfo;
    }

    public void setButtonVisible(boolean visible) {
        this.jButton1.setVisible(visible);
    }

    public void refresh() {
        readValues();
    }

    private void readValues() {
        DecimalFormat format = new DecimalFormat("##.#");
        if (procInfo != null) {
            this.idLabel.setText(String.valueOf(procInfo.id));
            this.familyLabel.setText(String.valueOf(procInfo.plat_family));
            this.nofCoresLabel.setText(String.valueOf(procInfo.nof_cores));
            this.CLabel.setText(String.valueOf(procInfo.C) + "/" + String.valueOf(procInfo.totalC));
            if (procInfo.totalC>0) {
                this.Cpercent.setText(format.format(100*(1-procInfo.C/procInfo.totalC)) + "%");
            } else {
                this.Cpercent.setText("N/A");
            }
            this.BWLabel.setText(String.valueOf(procInfo.intBW) + "/" + String.valueOf(procInfo.totalintBW));
            this.bwpercent.setText(format.format(100*(1-procInfo.intBW/procInfo.totalintBW)) + "%");
            this.CPULabel.setText(String.valueOf(procInfo.cpu_usec) + "/" + String.valueOf(procInfo.mean_tslot));
            if (procInfo.mean_tslot > 0) {
                this.cpupercent.setText(format.format(100*(float) (procInfo.cpu_usec/procInfo.mean_tslot)) + "%");
            } else {
                this.cpupercent.setText("N/A");
            }
            this.nameLabel.setText(procInfo.name);
        } else {
            this.idLabel.setText("Not Connected");
            this.familyLabel.setText("Not Connected");
            this.CLabel.setText("Not Connected");
            this.BWLabel.setText("Not Connected");
            this.nameLabel.setText("Not Connected");
        }

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        idLabel = new javax.swing.JLabel();
        familyLabel = new javax.swing.JLabel();
        CLabel = new javax.swing.JLabel();
        BWLabel = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        nameLabel = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        CPULabel = new javax.swing.JLabel();
        Cpercent = new javax.swing.JLabel();
        bwpercent = new javax.swing.JLabel();
        cpupercent = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        nofCoresLabel = new javax.swing.JLabel();

        setName("Form"); // NOI18N
        setLayout(new java.awt.GridBagLayout());

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(phalgui.PhalguiApp.class).getContext().getResourceMap(ProcessorView.class);
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        add(jLabel1, gridBagConstraints);

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        add(jLabel2, gridBagConstraints);

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        add(jLabel3, gridBagConstraints);

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        add(jLabel4, gridBagConstraints);

        idLabel.setText(resourceMap.getString("idLabel.text")); // NOI18N
        idLabel.setName("idLabel"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 13, 0, 0);
        add(idLabel, gridBagConstraints);

        familyLabel.setText(resourceMap.getString("familyLabel.text")); // NOI18N
        familyLabel.setName("familyLabel"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 13, 0, 0);
        add(familyLabel, gridBagConstraints);

        CLabel.setText(resourceMap.getString("CLabel.text")); // NOI18N
        CLabel.setName("CLabel"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 13, 0, 0);
        add(CLabel, gridBagConstraints);

        BWLabel.setText(resourceMap.getString("BWLabel.text")); // NOI18N
        BWLabel.setName("BWLabel"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 13, 0, 0);
        add(BWLabel, gridBagConstraints);

        jLabel5.setText(resourceMap.getString("jLabel5.text")); // NOI18N
        jLabel5.setName("jLabel5"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        add(jLabel5, gridBagConstraints);

        nameLabel.setText(resourceMap.getString("nameLabel.text")); // NOI18N
        nameLabel.setName("nameLabel"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 13, 0, 0);
        add(nameLabel, gridBagConstraints);

        jButton1.setText(resourceMap.getString("jButton1.text")); // NOI18N
        jButton1.setName("jButton1"); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        add(jButton1, gridBagConstraints);

        jLabel6.setText(resourceMap.getString("jLabel6.text")); // NOI18N
        jLabel6.setName("jLabel6"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel6, gridBagConstraints);

        CPULabel.setText(resourceMap.getString("CPULabel.text")); // NOI18N
        CPULabel.setName("CPULabel"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.insets = new java.awt.Insets(5, 13, 0, 0);
        add(CPULabel, gridBagConstraints);

        Cpercent.setText(resourceMap.getString("Cpercent.text")); // NOI18N
        Cpercent.setName("Cpercent"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.insets = new java.awt.Insets(5, 13, 0, 0);
        add(Cpercent, gridBagConstraints);

        bwpercent.setText(resourceMap.getString("bwpercent.text")); // NOI18N
        bwpercent.setName("bwpercent"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.insets = new java.awt.Insets(5, 13, 0, 0);
        add(bwpercent, gridBagConstraints);

        cpupercent.setText(resourceMap.getString("cpupercent.text")); // NOI18N
        cpupercent.setName("cpupercent"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.insets = new java.awt.Insets(5, 13, 0, 0);
        add(cpupercent, gridBagConstraints);

        jLabel7.setText(resourceMap.getString("jLabel7.text")); // NOI18N
        jLabel7.setName("jLabel7"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        add(jLabel7, gridBagConstraints);

        nofCoresLabel.setText(resourceMap.getString("nofCoresLabel.text")); // NOI18N
        nofCoresLabel.setName("nofCoresLabel"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 13, 0, 0);
        add(nofCoresLabel, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        if (procNode == null) {
            getprocNode();
        }
        if (procNode == null)
            return;
        SwingWorker w = new SwingWorker<Void,Void>() {

            @Override
            protected Void doInBackground() throws Exception {
                procNode.refresh();
                return null;
            }
            @Override
            protected void done() {
                readValues();
            }
        };
        w.execute();
    }//GEN-LAST:event_jButton1ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel BWLabel;
    private javax.swing.JLabel CLabel;
    private javax.swing.JLabel CPULabel;
    private javax.swing.JLabel Cpercent;
    private javax.swing.JLabel bwpercent;
    private javax.swing.JLabel cpupercent;
    private javax.swing.JLabel familyLabel;
    private javax.swing.JLabel idLabel;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel nameLabel;
    private javax.swing.JLabel nofCoresLabel;
    // End of variables declaration//GEN-END:variables

    @Override
    public String[] getTransferData() {
        String[] r = new String[1];
        r[0] = procName;
        return r;
    }


    @Override
    public void Close() {}

    @Override
    public void refreshPanel() {
        refresh();
    }

}
