/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package phalgui.Node.Repositories;


import phalgui.Node.*;
import java.io.File;
import java.util.Properties;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import phalgui.Control.MainControl;
import phalgui.Tree.*;
import phalgui.Node.Repositories.RepositoryObject.FileType;
import phalgui.Node.Repositories.RepositoryObject.UnknownRepositoryException;
import phalgui.PhalguiApp;
import phalgui.Utils.Arrows.ErrorParsingException;
import phalgui.Utils.JTabbedPaneWithIcon;

/**
 *
 * @author root
 */
public class DefaultRepository extends NodeObject {

    private FileType type = null;
    MainControl main;
    String name;

/*    public RepositoryEntry(JTabbedPaneWithIcon body, String name) {
        this(body, name,null,new String(),new String(), null);
    }
*/
    public DefaultRepository(MainControl main, String name, FileType type) {
        this(main, name, type, null);
    }

    public DefaultRepository(MainControl main, String name, FileType type, ImageIcon icon) {
        super(name,icon);
        this.type = type;
        this.main = main;
        this.name = name;
        setPopup(new TreePopup(buildMenu()));
    }
    
    public FileType getType() {
        return this.type;
    }

    @Override
    public boolean hasIcon() {
        return getIcon() != null;
    }
    @Override
    public ImageIcon getIcon() {
        ImageIcon icon = super.getIcon();
        if (icon == null)
            icon = type.getIcon();
        return icon;
    }


    public TreeMenuItem[] buildMenu() {
        TreeMenuItem items[] = new TreeMenuItem[1];
        items[0] = new TreeMenuItem("New") {
            public void action() { New(); }
            public boolean actionEnabled() { return true; }
            @Override
            public String getText() { return type.NewString; }
        };
        return items;
    }

    public void New() {
        String s = JOptionPane.showInputDialog("Enter a name for... " + type.NewString);
        if (s != null) {
            if (s.length() > 0) {
                try {
                    add(new RepositoryObject(type, main, s).getObject());
                } catch (Exception ex) {
                    System.out.println("Error creating repository object: " + ex.getMessage());
                }
            }
        }
    }

    @Override
    public String toString() {
        return name;
    }
    
    @Override
    public boolean WriteConfig(Properties props) {

        /* if not configured, do not write anything */
        if (type == null) {
            return false;
        }
        /* save my config */
        props.setProperty("repository." + toString() + ".type", type.shortName);
        
        String p = new String();
        for (int i = 0; i < getChildCount(); i++) {
            if (getChildAt(i).WriteConfig(props)) {
                p = p.concat(getChildAt(i).toString() + ",");
            }
        }
        /* remove last ',' and write list */
        if (p.length() > 0) {
            p = p.substring(0, p.length() - 1);
            if (p.length() > 0) {
                props.setProperty("repository." + toString(), p);
            }
        }
        return true;
    }

    @Override
    public boolean ReadConfig(Properties props) {
        String s;
        /* try to guess type, may fail */
        s = props.getProperty("repository." + toString() + ".type");
        if (s != null) {
            try {
                type = RepositoryObject.getType(s);

                String p = props.getProperty("repository." + toString());
                if (p != null) {
                    String reps[] = p.split(",");
                    for (int i = 0; i < reps.length; i++) {
                        RepositoryObject newrepos;
                        try {
                            newrepos = new RepositoryObject(type, main, reps[i]);
                            add(newrepos.getObject());
                            newrepos.getObject().ReadConfig(props);
                        } catch (UnknownRepositoryException ex) {
                            System.out.println("Error creating repos " + reps[i] + ": " + ex.getMessage());
                        }

                    }
                }
            } catch (ErrorParsingException ex) {
                System.out.print("Error obtaining type in Repository entry " + toString());
            }
        }
        return true;
    }
}
