/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package phalgui.Node.Repositories;


import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import phalControl.PlatformControl.WaveformNotFoundException;
import phalControl.StatControl;
import phalControl.commandManager.commandManager.ErrorInCommandException;
import phalgui.Control.MainControl.PlatformNotConnected;
import phalgui.Node.*;
import javax.swing.ImageIcon;
import javax.swing.SwingWorker;
import phalgui.Control.MainControl;
import phalControl.commandManager.StatInfo;
import phalgui.Tree.*;
import phalgui.Node.Stats.StatNode;
import phalgui.Node.Waveform.WaveformEntry;
import phalgui.PhalguiApp;

/**
 *
 * @author root
 */
public class StatsRepository extends NodeObject {

    MainControl main;
    private WaveformEntry waveform;
    private String obj_name;

    public StatsRepository(MainControl main, String name, WaveformEntry waveform, String objname) {
        this(main, name, waveform, objname, null);
    }

    public StatsRepository(MainControl main, String name, WaveformEntry waveform, String objname, ImageIcon icon) {
        super(name,icon);
        this.main = main;
        this.waveform = waveform;
        this.obj_name = objname;
        setPopup(new TreePopup(buildMenu()));
    }

   public TreeMenuItem[] buildMenu() {
        TreeMenuItem items[] = new TreeMenuItem[1];
        items[0] = new TreeMenuItem("Refresh") {
            public void action() { Reload(); }
            public boolean actionEnabled() { return true; }
        };
        return items;
    }
    private void Reload() {
        SwingWorker w = new SwingWorker<Void,Void>() {

            @Override
            protected Void doInBackground() throws Exception {
                main.getPlatform().getWaveform(waveform.toString()).refresh();
                return null;
            }
            @Override
            protected void done() {
                Refresh();
            }
        };
    }
    @Override
    public void Refresh() {
        StatControl[] stats;
        if (!main.isConnected())
            return;
        try {
            if (!main.getPlatform().isWaveformLoaded(waveform.toString()))
                return;
            stats = main.getPlatform().getWaveform(waveform.toString()).getStatControl(obj_name);
            if (stats == null)
                return;
            this.removeAllChilds();
            
            for (int i=0;i<stats.length;i++) {
                add(new StatNode(main, stats[i],waveform));
            }
             
        } catch (WaveformNotFoundException ex) {
            Logger.getLogger(StatsRepository.class.getName()).log(Level.SEVERE, null, ex);
        } catch (PlatformNotConnected ex) {
            Logger.getLogger(StatsRepository.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
