/*
 * MyColors.java
 *
 * Created on 25 de enero de 2002, 17:50
 */

package phalgui.Node.Stats;


import java.util.Vector;
import java.awt.Color;

/** This class supports some methods used by the different color comboboxes of some
 * option dialogs.
 * @see GraphicOptions
 * @see HistoOptions
 * @author  Santi Oliveras
 * @version 1.0  2/05/2002
 */
public class MyColors {

    public static int Size() {
        return 20;
    }

    /** Creates new MyColors */
    public MyColors() {
    }

    /** Returns a Vector with the names of some colours. */
    public static Vector getColors(){
        Vector colors= new Vector(22);
        colors.addElement("black");
        colors.addElement("blue");
        colors.addElement("cyan");
        colors.addElement("darkGray");
        colors.addElement("gray");
        colors.addElement("green");
        colors.addElement("lightGray");
        colors.addElement("magenta");
        colors.addElement("orange");
        colors.addElement("pink");
        colors.addElement("red");
        colors.addElement("white");
        colors.addElement("yellow"); 
        colors.addElement("lightBlue");
        colors.addElement("lightCyan");        
        colors.addElement("lightGreen");
        colors.addElement("lightMagenta");
        colors.addElement("lightOrange");
        colors.addElement("lightPink");        
        colors.addElement("lightRed");
        colors.addElement("lightYellow"); 
        colors.addElement("default");        
        return colors;
    }
    
    /** Returns an integer with the index of the colour.
     * @param c Color for getting the index in the colors vector.
     * @see #getColors
     */ 
    public static int getIndexColor(Color c){
        if(c.equals(Color.black))
            return 0;
        if(c.equals(Color.blue))
            return 1;
        if(c.equals(Color.cyan))
            return 2;
        if(c.equals(Color.darkGray))
            return 3;
        if(c.equals(Color.gray))
            return 4;
        if(c.equals(Color.green))
            return 5;
        if(c.equals(Color.lightGray))
            return 6;
        if(c.equals(Color.magenta))
            return 7;
        if(c.equals(Color.orange))
            return 8;
        if(c.equals(Color.pink))
            return 9;
        if(c.equals(Color.red))
            return 10;
        if(c.equals(Color.white))
            return 11;
        if(c.equals(Color.yellow))
            return 12;
        if(c.equals(new Color(160,160,255)))
            return 13;
        if(c.equals(new Color(160,255,255)))
            return 14;
        if(c.equals(new Color(160,255,160)))
            return 15;
        if(c.equals(new Color(255,160,255)))
            return 16;
        if(c.equals(new Color(255,220,160)))
            return 17;
        if(c.equals(new Color(255,200,200)))
            return 18;
        if(c.equals(new Color(255,160,160)))
            return 19;
        if(c.equals(new Color(255,255,160)))
            return 20;
        return 21;    
    }
    
    /** Returns the Color with the specified color name.    
     * @param name String with the name of the colour.
     */
    public static Color decodeColor(String name){
        if(name.equalsIgnoreCase("black"))
            return Color.black;
        if(name.equalsIgnoreCase("blue"))
            return Color.blue;
        if(name.equalsIgnoreCase("cyan"))
            return Color.cyan;
        if(name.equalsIgnoreCase("darkGray"))
            return Color.darkGray;
        if(name.equalsIgnoreCase("gray"))
            return Color.gray;
        if(name.equalsIgnoreCase("green"))
            return Color.green;
        if(name.equalsIgnoreCase("lightGray"))
            return Color.lightGray;
        if(name.equalsIgnoreCase("magenta"))
            return Color.magenta;
        if(name.equalsIgnoreCase("orange"))
            return Color.orange;
        if(name.equalsIgnoreCase("pink"))
            return Color.pink;
        if(name.equalsIgnoreCase("red"))
            return Color.red;
        if(name.equalsIgnoreCase("yellow"))
            return Color.yellow;
        if(name.equalsIgnoreCase("white"))
            return Color.white;
        if(name.equalsIgnoreCase("lightBlue"))
            return new Color(160,160,255);
        if(name.equalsIgnoreCase("lightCyan"))
            return new Color(160,255,255); 
        if(name.equalsIgnoreCase("lightGreen"))
            return new Color(160,255,160);
        if(name.equalsIgnoreCase("lightMagenta"))
            return new Color(255,160,255);
        if(name.equalsIgnoreCase("lightOrange"))
            return new Color(255,220,160);
        if(name.equalsIgnoreCase("lightPink"))
            return new Color(255,200,200);
        if(name.equalsIgnoreCase("lightRed"))
            return new Color(255,160,160);
        if(name.equalsIgnoreCase("lightYellow"))
            return new Color(255,255,160);
        return new Color(204,204,204);    
    }
    
    /** Returns the Color with the specified index in the color vector.    
     * @param index Integer with the index of the colour in the colour vector.
     * @see #getColors
     */
    public static Color decodeColor(int index){
        if(index==0)
            return Color.black;
        if(index==1)
            return Color.blue;
        if(index==2)
            return Color.cyan;
        if(index==3)
            return Color.darkGray;
        if(index==4)
            return Color.gray;
        if(index==5)
            return Color.green;
        if(index==6)
            return Color.lightGray;
        if(index==7)
            return Color.magenta;
        if(index==8)
            return Color.orange;
        if(index==9)
            return Color.pink;
        if(index==10)
            return Color.red;        
        if(index==11)
            return Color.white;
        if(index==12)
            return Color.yellow;
        if(index==13)
            return new Color(160,160,255);
        if(index==14)
            return new Color(160,255,255); 
        if(index==15)
            return new Color(160,255,160);
        if(index==16)
            return new Color(255,160,255);
        if(index==17)
            return new Color(255,220,160);
        if(index==18)
            return new Color(255,200,200);
        if(index==19)
            return new Color(255,160,160);
        if(index==20)
            return new Color(255,255,160);
        return new Color(204,204,204);    
    }
    
    
}
