/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * StatOptionsPanel.java
 *
 * Created on 20-feb-2009, 11:39:19
 */

package phalgui.Node.Stats;

import java.awt.Color;
import java.text.DecimalFormat;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFrame;
import phalControl.StatControl;
import phalControl.commandManager.commandManager.ErrorInCommandException;
import phalgui.Utils.VectorId;

/**
 *
 * @author ismael
 */
public class ReportOptionsPanel extends javax.swing.JPanel {
    private StatControl stat;
    final int MAX_PERIOD_SLOTS = 200;
    final int MIN_PERIOD_SLOTS = 2;
    final int MAX_WINDOW_SLOTS = 200;
    final int MIN_WINDOW_SLOTS = 1;
    private boolean captureall;
    private boolean triggerPeriodic,auto=true;

    /** Creates new form StatOptionsPanel */
    public ReportOptionsPanel() {
        initComponents();
        triggervalueRadio.setEnabled(true);
        triggerperiodicRadio.setSelected(true);
        triggerValue.setVisible(false);
        triggerPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Trigger Type"));
        windowPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Window Length"));
        infoPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Current Parameters"));
        triggerperiodicRadio.setText("Periodic");
        triggervalueRadio.setText("Value");
        this.periodValue.setText(String.valueOf(periodSlider.getValue()) + " slots");
        this.periodSlider.setMajorTickSpacing(MAX_PERIOD_SLOTS/20);
        this.periodSlider.setMaximum(MAX_PERIOD_SLOTS);
        this.periodSlider.setMinimum(MIN_PERIOD_SLOTS);
        this.windowSlider.setMajorTickSpacing(MAX_WINDOW_SLOTS/20);
        this.windowSlider.setMaximum(MAX_WINDOW_SLOTS);
        this.windowSlider.setMinimum(MIN_WINDOW_SLOTS);
        this.windowValue.setText(String.valueOf(periodSlider.getValue()) + " slots");
        captureallLabel.setText("Capture all");
        setInfoVisible(false);
        setTriggerVisible(false);
        getButton.setVisible(false);
        triggervalueRadio.setEnabled(false);
        triggerperiodicRadio.setSelected(true);
    }

    public String isVisibleString() {
        String s = new String("");
        s = s.concat(infoPanel.isVisible()?"y":"n");
        s = s.concat(windowPanel.isVisible()?"y":"n");
        s = s.concat(triggerPanel.isVisible()?"y":"n");
        return s;
    }

    public void setVisibleString(String s) {
        if (s.length()<3)
            return;
        infoPanel.setVisible(String.valueOf(s.charAt(0)).equals("y"));
        windowPanel.setVisible(String.valueOf(s.charAt(1)).equals("y"));
        triggerPanel.setVisible(String.valueOf(s.charAt(2)).equals("y"));
    }

    public void setInfoVisible(boolean visible) {
        infoPanel.setVisible(visible);
    }
    public void setWindowVisible(boolean visible) {
        windowPanel.setVisible(visible);
    }
    public void setTriggerVisible(boolean visible) {
        triggerPanel.setVisible(visible);
    }


    Vector statsControl = new Vector<StatControl>();
    void addStatControl(StatControl stat) {
        this.statsControl.add(stat);
        if (statsControl.size()==1) {
            this.stat=stat;
            setPeriodValue(stat.getTriggerPeriod());
            setWindowValue(stat.getWindow());
            triggerPeriodic = stat.isTriggerPeriodic();
            captureall = (getPeriod() == getWindow());
            triggerValue.setText(String.valueOf(stat.getTriggerValue()));
        }
        adjustValues();
    }
    void removeStatControl(StatControl stat) {
        this.statsControl.remove(stat);
    }

    public void setManualMode() {
        setWindowVisible(true);
        setTriggerVisible(false);
        setInfoVisible(false);
        getButton.setVisible(true);
        captureallLabel.setVisible(false);
        auto = false;
    }

    void setAutoMode() {
        setWindowVisible(false);
        setTriggerVisible(true);
        setInfoVisible(false);
        getButton.setVisible(false);
        captureallLabel.setVisible(true);
        auto = true;
    }

    void updateText() {
        String s = doubleToString(stat.getSize()*getWindow());
        if (s.contains(".")) {
            s = s.substring(0,s.lastIndexOf("."));
        }
        currentWindowLabel.setText("Window: " + s + " samples");
        if (triggerperiodicRadio.isSelected()) {
            currentTriggerLabel.setText("Periodic trigger: " + doubleToString((double) stat.getSlotDurationMs()*getPeriod()/1000) + "s");
        } else {
            currentTriggerLabel.setText("Value trigger: " + getValue());
        }
        speedLabel.setText("Capture speed: " + doubleToString(sampleSpeed()) + "Hz");
        slotDurationLabel.setText("Object slot duration: " + stat.getSlotDurationMs() + " ms");
        sizeLabel.setText("Variable size: " + stat.getSize());

        triggerValue.setVisible(!triggerPeriodic);
        periodSlider.setVisible(triggerPeriodic);
        periodValue.setVisible(triggerPeriodic);
        captureallLabel.setSelected(captureall);
    }

    void adjustValues() {
        if (auto) {
            if (captureall) {
                setWindowValue(getPeriod());
            } else {
                if (getWindow() > getPeriod()) {
                    setWindowValue(getPeriod());
                }
            }
        }

        checkUpdates();
        
        updateText();

        if (triggerPeriodic) {
            try {
                for (int i=0;i<statsControl.size();i++) {
                    ((StatControl) statsControl.get(i)).setPeriodicTrigger(getPeriod(), getWindow());
                }
            } catch (ErrorInCommandException ex) {
                Logger.getLogger(ReportOptionsPanel.class.getName()).log(Level.SEVERE, null, ex);
            }
        } else {
            try {
                for (int i=0;i<statsControl.size();i++) {
                    ((StatControl) statsControl.get(i)).setValueTrigger(getValue(), getWindow());
                }
                
            } catch (ErrorInCommandException ex) {
                Logger.getLogger(ReportOptionsPanel.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    String doubleToString(double x) {
        DecimalFormat df = new DecimalFormat();
        df.applyPattern("#0.#");

        if (x>1000000) {
            return df.format(x/1000000) + " M";
        } else if (x>1000) {
            return df.format(x/1000) + " k";
        } else if (x < 0.0001) {
            return df.format(x*1000) + " m";
        } else {
            return df.format(x) + " ";
        }
    }

    double sampleSpeed() {
        return ((double) (1000*getWindow()*stat.getSize())/(stat.getSlotDurationMs()*getPeriod()));
    }

    int getPeriod() {
        return periodSlider.getValue();
    }

    int getWindow() {
        return windowSlider.getValue();
    }

    double getValue() {
        return new Double(triggerValue.getText());
    }

    void setPeriodValue(int value) {
        this.periodSlider.setValue(value);
        this.periodValue.setText(String.valueOf(periodSlider.getValue()) + " slots");
    }
    void setWindowValue(int value) {
        this.windowSlider.setValue(value);
        this.windowValue.setText(String.valueOf(windowSlider.getValue()) + " slots");
    }

    private void checkUpdates() {
        if (getPeriod() != stat.getTriggerPeriod()) {
            callTriggerPeriodModified();
        }
        if (getWindow() != stat.getWindow()) {
            callWindowModified();
        }

    }



    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        triggerPanel = new javax.swing.JPanel();
        triggerperiodicRadio = new javax.swing.JRadioButton();
        triggervalueRadio = new javax.swing.JRadioButton();
        periodSlider = new javax.swing.JSlider();
        periodValue = new javax.swing.JLabel();
        triggerValue = new javax.swing.JTextField();
        windowPanel = new javax.swing.JPanel();
        windowSlider = new javax.swing.JSlider();
        windowValue = new javax.swing.JLabel();
        captureallLabel = new javax.swing.JCheckBox();
        getButton = new javax.swing.JButton();
        infoPanel = new javax.swing.JPanel();
        currentWindowLabel = new javax.swing.JLabel();
        currentTriggerLabel = new javax.swing.JLabel();
        speedLabel = new javax.swing.JLabel();
        slotDurationLabel = new javax.swing.JLabel();
        sizeLabel = new javax.swing.JLabel();

        setName("Form"); // NOI18N
        setLayout(new java.awt.GridBagLayout());

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(phalgui.PhalguiApp.class).getContext().getResourceMap(ReportOptionsPanel.class);
        triggerPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, resourceMap.getString("windowPanel.border.title"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, resourceMap.getFont("windowPanel.border.titleFont"))); // NOI18N
        triggerPanel.setName("triggerPanel"); // NOI18N
        triggerPanel.setLayout(new java.awt.GridBagLayout());

        triggerperiodicRadio.setFont(resourceMap.getFont("periodValue.font")); // NOI18N
        triggerperiodicRadio.setText(resourceMap.getString("triggerperiodicRadio.text")); // NOI18N
        triggerperiodicRadio.setName("triggerperiodicRadio"); // NOI18N
        triggerperiodicRadio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                triggerperiodicRadioActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        triggerPanel.add(triggerperiodicRadio, gridBagConstraints);

        triggervalueRadio.setFont(resourceMap.getFont("periodValue.font")); // NOI18N
        triggervalueRadio.setText(resourceMap.getString("triggervalueRadio.text")); // NOI18N
        triggervalueRadio.setName("triggervalueRadio"); // NOI18N
        triggervalueRadio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                triggervalueRadioActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        triggerPanel.add(triggervalueRadio, gridBagConstraints);

        periodSlider.setFont(resourceMap.getFont("periodValue.font")); // NOI18N
        periodSlider.setMajorTickSpacing(5);
        periodSlider.setPaintTicks(true);
        periodSlider.setName("periodSlider"); // NOI18N
        periodSlider.setPreferredSize(new java.awt.Dimension(200, 44));
        periodSlider.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                periodSliderMouseReleased(evt);
            }
        });
        periodSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                periodSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 2.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 17, 0, 0);
        triggerPanel.add(periodSlider, gridBagConstraints);

        periodValue.setFont(resourceMap.getFont("periodValue.font")); // NOI18N
        periodValue.setText(resourceMap.getString("periodValue.text")); // NOI18N
        periodValue.setName("periodValue"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(0, 17, 0, 0);
        triggerPanel.add(periodValue, gridBagConstraints);

        triggerValue.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        triggerValue.setText(resourceMap.getString("triggerValue.text")); // NOI18N
        triggerValue.setName("triggerValue"); // NOI18N
        triggerValue.setPreferredSize(new java.awt.Dimension(70, 20));
        triggerValue.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                triggerValueKeyPressed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        triggerPanel.add(triggerValue, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 4.0;
        add(triggerPanel, gridBagConstraints);

        windowPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, resourceMap.getString("windowPanel.border.title"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, resourceMap.getFont("windowPanel.border.titleFont"))); // NOI18N
        windowPanel.setName("windowPanel"); // NOI18N
        windowPanel.setLayout(new java.awt.GridBagLayout());

        windowSlider.setFont(resourceMap.getFont("periodValue.font")); // NOI18N
        windowSlider.setPaintTicks(true);
        windowSlider.setName("windowSlider"); // NOI18N
        windowSlider.setPreferredSize(new java.awt.Dimension(200, 44));
        windowSlider.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                windowSliderMouseReleased(evt);
            }
        });
        windowSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                windowSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 2.0;
        windowPanel.add(windowSlider, gridBagConstraints);

        windowValue.setFont(resourceMap.getFont("periodValue.font")); // NOI18N
        windowValue.setText(resourceMap.getString("windowValue.text")); // NOI18N
        windowValue.setName("windowValue"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        windowPanel.add(windowValue, gridBagConstraints);

        captureallLabel.setFont(resourceMap.getFont("periodValue.font")); // NOI18N
        captureallLabel.setText(resourceMap.getString("captureallLabel.text")); // NOI18N
        captureallLabel.setName("captureallLabel"); // NOI18N
        captureallLabel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                captureallLabelActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 0);
        windowPanel.add(captureallLabel, gridBagConstraints);

        getButton.setText(resourceMap.getString("getButton.text")); // NOI18N
        getButton.setName("getButton"); // NOI18N
        getButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                getButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        windowPanel.add(getButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        add(windowPanel, gridBagConstraints);

        infoPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, resourceMap.getString("infoPanel.border.title"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, resourceMap.getFont("infoPanel.border.titleFont"))); // NOI18N
        infoPanel.setName("infoPanel"); // NOI18N
        infoPanel.setLayout(new java.awt.GridBagLayout());

        currentWindowLabel.setFont(resourceMap.getFont("speedLabel.font")); // NOI18N
        currentWindowLabel.setText(resourceMap.getString("currentWindowLabel.text")); // NOI18N
        currentWindowLabel.setName("currentWindowLabel"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        infoPanel.add(currentWindowLabel, gridBagConstraints);

        currentTriggerLabel.setFont(resourceMap.getFont("speedLabel.font")); // NOI18N
        currentTriggerLabel.setText(resourceMap.getString("currentTriggerLabel.text")); // NOI18N
        currentTriggerLabel.setName("currentTriggerLabel"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        infoPanel.add(currentTriggerLabel, gridBagConstraints);

        speedLabel.setFont(resourceMap.getFont("speedLabel.font")); // NOI18N
        speedLabel.setText(resourceMap.getString("speedLabel.text")); // NOI18N
        speedLabel.setName("speedLabel"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        infoPanel.add(speedLabel, gridBagConstraints);

        slotDurationLabel.setFont(resourceMap.getFont("speedLabel.font")); // NOI18N
        slotDurationLabel.setText(resourceMap.getString("slotDurationLabel.text")); // NOI18N
        slotDurationLabel.setName("slotDurationLabel"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        infoPanel.add(slotDurationLabel, gridBagConstraints);

        sizeLabel.setFont(resourceMap.getFont("speedLabel.font")); // NOI18N
        sizeLabel.setText(resourceMap.getString("sizeLabel.text")); // NOI18N
        sizeLabel.setName("sizeLabel"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        infoPanel.add(sizeLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(infoPanel, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents


    private void periodSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_periodSliderStateChanged
        // TODO add your handling code here:
        setPeriodValue(periodSlider.getValue());
        if (captureall) {
            setWindowValue(getPeriod());
        }
    }//GEN-LAST:event_periodSliderStateChanged

    private void windowSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_windowSliderStateChanged
        // TODO add your handling code here:
        setWindowValue(windowSlider.getValue());
        
    }//GEN-LAST:event_windowSliderStateChanged

    private void windowSliderMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_windowSliderMouseReleased
        // TODO add your handling code here:
        if (auto)
            adjustValues();
    }//GEN-LAST:event_windowSliderMouseReleased

    private void periodSliderMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_periodSliderMouseReleased
        // TODO add your handling code here:
        adjustValues();
    }//GEN-LAST:event_periodSliderMouseReleased

    private void captureallLabelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_captureallLabelActionPerformed
        // TODO add your handling code here:
        captureall = captureallLabel.isSelected();
        windowSlider.setEnabled(!captureall);
        adjustValues();
    }//GEN-LAST:event_captureallLabelActionPerformed

    private void triggervalueRadioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_triggervalueRadioActionPerformed
        // TODO add your handling code here:
  //      triggerPeriodic = !triggervalueRadio.isSelected();
    //    triggerperiodicRadio.setSelected(triggerPeriodic);
   //     adjustValues();
    }//GEN-LAST:event_triggervalueRadioActionPerformed

    private void triggerperiodicRadioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_triggerperiodicRadioActionPerformed
        // TODO add your handling code here:
    //    triggerPeriodic = triggerperiodicRadio.isSelected();
    //    triggervalueRadio.setSelected(!triggerPeriodic);
    //    adjustValues();
    }//GEN-LAST:event_triggerperiodicRadioActionPerformed

    private void triggerValueKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_triggerValueKeyPressed
        // TODO add your handling code here:
        triggerValue.setBackground(Color.LIGHT_GRAY);
        if (evt.getKeyCode() == java.awt.event.KeyEvent.VK_ENTER) {
            triggerValue.setBackground(Color.WHITE);
            adjustValues();
        }
    }//GEN-LAST:event_triggerValueKeyPressed

    private void getButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_getButtonActionPerformed
        // TODO add your handling code here:
        callGetButtonAction();
    }//GEN-LAST:event_getButtonActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox captureallLabel;
    private javax.swing.JLabel currentTriggerLabel;
    private javax.swing.JLabel currentWindowLabel;
    private javax.swing.JButton getButton;
    private javax.swing.JPanel infoPanel;
    private javax.swing.JSlider periodSlider;
    private javax.swing.JLabel periodValue;
    private javax.swing.JLabel sizeLabel;
    private javax.swing.JLabel slotDurationLabel;
    private javax.swing.JLabel speedLabel;
    private javax.swing.JPanel triggerPanel;
    private javax.swing.JTextField triggerValue;
    private javax.swing.JRadioButton triggerperiodicRadio;
    private javax.swing.JRadioButton triggervalueRadio;
    private javax.swing.JPanel windowPanel;
    private javax.swing.JSlider windowSlider;
    private javax.swing.JLabel windowValue;
    // End of variables declaration//GEN-END:variables

    Vector listeners = new Vector<ReportOptionsPanelListener>();
    public void addReportOptionsPanelListener(ReportOptionsPanelListener listener) {
        listeners.add(listener);
    }
    public void removeReportOptionsPanelListener(ReportOptionsPanelListener listener) {
        listeners.remove(listener);
    }


    private void callGetButtonAction() {
        for (int i=0;i<listeners.size();i++) {
            ((ReportOptionsPanelListener) listeners.get(i)).GetButtonAction();
        }
    }

    private void callWindowModified() {
        for (int i=0;i<listeners.size();i++) {
            ((ReportOptionsPanelListener) listeners.get(i)).WindowModified(getWindow());
        }
    }
    private void callTriggerPeriodModified() {
        for (int i=0;i<listeners.size();i++) {
            ((ReportOptionsPanelListener) listeners.get(i)).TriggerPeriodModified(getPeriod());
        }
    }
    private void callTriggerTypeModified() {
        for (int i=0;i<listeners.size();i++) {
            ((ReportOptionsPanelListener) listeners.get(i)).TriggerTypeModified(triggerperiodicRadio.isSelected());
        }
    }

    public interface ReportOptionsPanelListener {
        public void WindowModified(int window);
        public void TriggerPeriodModified(int period);
        public void TriggerTypeModified(boolean isPeriod);
        public void GetButtonAction();
    }
}
