/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * StatModify.java
 *
 * Created on 15-feb-2009, 22:22:39
 */
package phalgui.Node.Stats;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFrame;
import phalControl.PlatformControl.WaveformNotFoundException;
import phalControl.StatControl;
import phalControl.StatControl.InvalidReportFormat;
import phalControl.commandManager.commandManager.ErrorInCommandException;
import phalgui.Control.MainControl.PlatformNotConnected;
import phalgui.PhalguiApp;
import phalgui.Utils.Arrows.ValueStamp;
import phalgui.Utils.DnD.TransfResizePanel;

/**
 *
 * @author ismael
 */
public class StatModifyPanel extends TransfResizePanel implements GraphicPanel.addGraphicInterface {

    private StatControl stat;
    private String statName;
    private String objName;
    private String waveformName;
    private SetListener listener;

    /** Creates new form StatModify */
    public StatModifyPanel() {
        initComponents();
    }

    public static void main(String[] args) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                JFrame f = new JFrame();
                StatControl s = new StatControl("hola");

                StatModifyPanel m = new StatModifyPanel(s);
                f.add(m);
                f.setVisible(true);
                f.pack();
                f.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
            }
        });
    }

    String getValue() {
        return valueTextField.getText();
    }

    @Override
    public void refreshPanel() {
        getStat();
    }

    interface SetListener {
        public void SetButtonAction(String data);
    }

    void setSetListener(SetListener listener) {
        this.listener = listener;
    }

    void callSetListeners(String data) {
        if (listener != null) {
            this.listener.SetButtonAction(data);
        }
    }

    private void getStat() {
        try {
            this.stat = ((PhalguiApp) PhalguiApp.getApplication()).getMainControl().getPlatform().getWaveform(waveformName).getStatControl(objName, statName);
        } catch (PlatformNotConnected ex) {
            Logger.getLogger(StatModifyPanel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (WaveformNotFoundException ex) {
            Logger.getLogger(StatModifyPanel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ErrorInCommandException ex) {
            Logger.getLogger(StatModifyPanel.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public StatModifyPanel(String[] info) {
        this();
        this.waveformName = info[0];
        this.objName = info[1];
        this.statName = info[2];
        getStat();
        setStatControl(stat);
    }
     
    public StatModifyPanel(StatControl s) {
        this();
        setStatControl(s);
        this.statName = s.toString();
        this.objName = s.getObjectName();
        this.waveformName = s.getWaveformName();
    }

    public void setStatControl(StatControl s) {
        if (s==null)
            return;
        this.stat = s;
        setButton.setText("Set");
        valueLabel.setText("Value");
        try {
            ValueStamp data[] = s.getValue();
            if (data == null) {
                valueTextField.setText("0");
                return;
            }
            if (data.length > 0) {
                valueTextField.setText(data[0].getValue());
            } else {
                valueTextField.setText("0");
            }
        } catch (ErrorInCommandException ex) {
            Logger.getLogger(StatModifyPanel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(StatModifyPanel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (InvalidReportFormat ex) {
            Logger.getLogger(StatModifyPanel.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        valueLabel = new javax.swing.JLabel();
        setButton = new javax.swing.JButton();
        valueTextField = new javax.swing.JTextField();

        setName("Form"); // NOI18N
        setLayout(new java.awt.GridBagLayout());

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(phalgui.PhalguiApp.class).getContext().getResourceMap(StatModifyPanel.class);
        valueLabel.setText(resourceMap.getString("valueLabel.text")); // NOI18N
        valueLabel.setName("valueLabel"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 8, 0, 0);
        add(valueLabel, gridBagConstraints);

        setButton.setText(resourceMap.getString("setButton.text")); // NOI18N
        setButton.setName("setButton"); // NOI18N
        setButton.setPreferredSize(new java.awt.Dimension(50, 29));
        setButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        add(setButton, gridBagConstraints);

        valueTextField.setText(resourceMap.getString("valueTextField.text")); // NOI18N
        valueTextField.setName("valueTextField"); // NOI18N
        valueTextField.setPreferredSize(new java.awt.Dimension(110, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.weightx = 1.0;
        add(valueTextField, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void setButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setButtonActionPerformed
        // TODO add your handling code here:
        if (this.stat == null) {
            getStat();
        }
        if (this.stat == null)
            return;
        try {
            stat.setValue(valueTextField.getText());
            callSetListeners(valueTextField.getText());
        } catch (ErrorInCommandException ex) {
            valueTextField.setText("Error!");
        }

    }//GEN-LAST:event_setButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton setButton;
    private javax.swing.JLabel valueLabel;
    private javax.swing.JTextField valueTextField;
    // End of variables declaration//GEN-END:variables

    public void addtoGraphic(GraphicInterface gi) {
    }

    @Override
    public String[] getTransferData() {
        String[] info = new String[3];
        info[0] = waveformName;
        info[1] = objName;
        info[2] = statName;
        return info;
    }

    @Override
    public void Close() {
    }
}
