/*
 * StatisticsPanel.java
 *
 * Created on 11 de enero de 2002, 12:56
 */

package phalgui.Node.Stats;

/** This class supports the methods relationated with the statisticsPanel.
 * @author  Santi Oliveras
 * @version 1.0  3/05/2002
 * @see StatisticsVector
 * @see GraphicFrame
 * @see StatisticsGraphic
 */
public class StatisticsPanel extends javax.swing.JPanel {
    
    
    // ******** constructor ****************************************************
    
    /** Creates new form StatisticsPanel */
    public StatisticsPanel() {
        initComponents();
    }

    public StatisticsPanel(boolean selected) {
        this();
        this.advStatisticsCheckBox.setSelected(selected);
        this.advStatisticsCheckBoxActionPerformed(null);
    }

    
    // ******** public methods *************************************************
    
    /** Sets the values to the statistic panel.
     * @param average Double with the average value
     * @param desviation Double with the desviation value
     * @param maximum Double with the maximum value
     * @param minimum Double with the minimum value
     */
    public void setNewValues(double average, double desviation, double maximum, double minimum){
        averageValueLabel.setText(Double.toString(Math.round(average*100d)/100d));
        desviationValueLabel.setText(Double.toString(Math.round(desviation*100d)/100d));
        maximumValueLabel.setText(Double.toString(Math.round(maximum*100d)/100d));
        minimumValueLabel.setText(Double.toString(Math.round(minimum*100d)/100d));    
    }
    
    /** Enables or disables the panel and its components.
     * @param b If true, the pane is enabled
     */
    public void setEnabled(boolean b){
        advStatisticsCheckBox.setEnabled(b);
        jPanel2.setEnabled(b);
        jPanel2.setBorder(new javax.swing.border.TitledBorder(null, "Statistics", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 11), new java.awt.Color(153, 153, 153)));        
        averageLabel.setEnabled(b);
        averageValueLabel.setEnabled(b);
        desviationLabel.setEnabled(b);
        desviationValueLabel.setEnabled(b);
        maximumLabel.setEnabled(b);
        maximumValueLabel.setEnabled(b);
        minimumLabel.setEnabled(b);
        minimumValueLabel.setEnabled(b);
    }
    
    
    // ******** private methods ************************************************
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        advStatisticsCheckBox = new javax.swing.JCheckBox();
        jPanel2 = new javax.swing.JPanel();
        averageLabel = new javax.swing.JLabel();
        averageValueLabel = new javax.swing.JLabel();
        desviationLabel = new javax.swing.JLabel();
        desviationValueLabel = new javax.swing.JLabel();
        maximumLabel = new javax.swing.JLabel();
        maximumValueLabel = new javax.swing.JLabel();
        minimumLabel = new javax.swing.JLabel();
        minimumValueLabel = new javax.swing.JLabel();
        
        setLayout(new java.awt.BorderLayout());
        
        advStatisticsCheckBox.setSelected(true);
        advStatisticsCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        advStatisticsCheckBox.setText("Advanced Statistics");
        advStatisticsCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                advStatisticsCheckBoxActionPerformed(evt);
            }
        });
        
        add(advStatisticsCheckBox, java.awt.BorderLayout.SOUTH);
        
        jPanel2.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jPanel2.setBorder(new javax.swing.border.TitledBorder(null, "Statistics", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 11), java.awt.Color.black));
        averageLabel.setText("   Average:");
        averageLabel.setForeground(java.awt.Color.black);
        averageLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weighty = 1.0;
        jPanel2.add(averageLabel, gridBagConstraints1);
        
        averageValueLabel.setForeground(java.awt.Color.black);
        averageValueLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        averageValueLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 10);
        gridBagConstraints1.weightx = 1.0;
        jPanel2.add(averageValueLabel, gridBagConstraints1);
        
        desviationLabel.setText("   Standar desviation:");
        desviationLabel.setForeground(java.awt.Color.black);
        desviationLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weighty = 1.0;
        jPanel2.add(desviationLabel, gridBagConstraints1);
        
        desviationValueLabel.setForeground(java.awt.Color.black);
        desviationValueLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        desviationValueLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 10);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        jPanel2.add(desviationValueLabel, gridBagConstraints1);
        
        maximumLabel.setText("   Maximum:");
        maximumLabel.setForeground(java.awt.Color.black);
        maximumLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weighty = 1.0;
        jPanel2.add(maximumLabel, gridBagConstraints1);
        
        maximumValueLabel.setForeground(java.awt.Color.black);
        maximumValueLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        maximumValueLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 10);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        jPanel2.add(maximumValueLabel, gridBagConstraints1);
        
        minimumLabel.setText("   Minimum:");
        minimumLabel.setForeground(java.awt.Color.black);
        minimumLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weighty = 1.0;
        jPanel2.add(minimumLabel, gridBagConstraints1);
        
        minimumValueLabel.setForeground(java.awt.Color.black);
        minimumValueLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        minimumValueLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 10);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        jPanel2.add(minimumValueLabel, gridBagConstraints1);
        
        add(jPanel2, java.awt.BorderLayout.CENTER);
        
    }//GEN-END:initComponents

    /** Hides or shows the advanced Statistics (maximum,minimum and desviation)
     * this method is called when advStatistics checkbox is changed.
     **/
    private void advStatisticsCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_advStatisticsCheckBoxActionPerformed
        if(!advStatisticsCheckBox.isSelected()){
            desviationLabel.setVisible(false);
            maximumLabel.setVisible(false);
            minimumLabel.setVisible(false);
            desviationValueLabel.setVisible(false);
            maximumValueLabel.setVisible(false);
            minimumValueLabel.setVisible(false);
            setSize(getPreferredSize());
        }
        else{
            desviationLabel.setVisible(true);
            maximumLabel.setVisible(true);
            minimumLabel.setVisible(true);
            desviationValueLabel.setVisible(true);
            maximumValueLabel.setVisible(true);
            minimumValueLabel.setVisible(true);
            setSize(getPreferredSize());
        }
            
    }//GEN-LAST:event_advStatisticsCheckBoxActionPerformed

 
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox advStatisticsCheckBox;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JLabel averageLabel;
    private javax.swing.JLabel averageValueLabel;
    private javax.swing.JLabel desviationLabel;
    private javax.swing.JLabel desviationValueLabel;
    private javax.swing.JLabel maximumLabel;
    private javax.swing.JLabel maximumValueLabel;
    private javax.swing.JLabel minimumLabel;
    private javax.swing.JLabel minimumValueLabel;
    // End of variables declaration//GEN-END:variables

}
