/*
 * ValuePanel.java
 *
 * Created on 11 de enero de 2002, 12:37
 */

package phalgui.Node.Stats;

/** This class supports the methods relationated with the ValuePanel. This panel
 * is used to show the current value of the variable.
 * @author  Santi Oliveras
 * @version 1.0  3/05/2002
 * @see GraphicFrame
 * @see StatisticsGraphic
 */
public class ValuePanel extends javax.swing.JPanel {

    // ******** constructor ****************************************************
    
    /** Creates new form ValuePanel. */
    public ValuePanel() {
        initComponents();
    }

    
    // ******** public methods *************************************************
    
    /** Set the current value into the textField.
     * @param value String with the current value
     */
    public void setCurrentValue(String value){
        currentValue.setText(value);
    }
    
    /** Enables or disables the components of the panel.
     * @param b It true, the panel is set enabled
     */
    public void setEnabled(boolean b){
        jLabel1.setEnabled(b);
        currentValue.setEnabled(false);
    }
    
    
    // ******** private methods ************************************************
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        currentValue = new javax.swing.JTextField();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jLabel1.setText("Current Value:  ");
        jLabel1.setForeground(java.awt.Color.black);
        jLabel1.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        add(jLabel1, gridBagConstraints1);
        
        currentValue.setDisabledTextColor(java.awt.Color.black);
        currentValue.setPreferredSize(new java.awt.Dimension(50, 21));
        currentValue.setMargin(new java.awt.Insets(0, 5, 0, 0));
        currentValue.setEnabled(false);
        currentValue.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                currentValueComponentResized(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 10, 0, 0);
        gridBagConstraints1.weightx = 1.0;
        add(currentValue, gridBagConstraints1);
        
    }//GEN-END:initComponents

    /** Sets the preferred size as the current size.
     * This method is called when the panel is resized. */
    private void currentValueComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_currentValueComponentResized
        currentValue.setPreferredSize(currentValue.getSize());
    }//GEN-LAST:event_currentValueComponentResized
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextField currentValue;
    // End of variables declaration//GEN-END:variables

}
