    /*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SGTPlot.java
 *
 * Created on 25-feb-2009, 12:18:08
 */

package phalgui.Node.Stats;

import gov.noaa.pmel.sgt.CartesianGraph;
import gov.noaa.pmel.sgt.JPane;
import gov.noaa.pmel.sgt.Layer;
import gov.noaa.pmel.sgt.LineAttribute;
import gov.noaa.pmel.sgt.LinearTransform;
import gov.noaa.pmel.sgt.PlainAxis;
import gov.noaa.pmel.sgt.SGLabel;
import gov.noaa.pmel.sgt.StackedLayout;
import gov.noaa.pmel.sgt.TimeAxis;
import gov.noaa.pmel.sgt.dm.SGTData;
import gov.noaa.pmel.sgt.dm.SGTLine;
import gov.noaa.pmel.util.Dimension2D;
import gov.noaa.pmel.util.Point2D;
import gov.noaa.pmel.util.SoTPoint;
import gov.noaa.pmel.util.SoTRange;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.ContainerEvent;
import java.awt.event.ContainerListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JFrame;

/**
 *
 * @author ismael
 */
public class sgPlot extends javax.swing.JPanel implements ComponentListener,PropertyChangeListener {
    private JPane pane_;
    private LinearTransform xt_;
    private LinearTransform yt_;
    private Layer layer_;
    private PlainAxis xbot_;
    private PlainAxis yleft_;
    private sgData data;



    public static void main(String[] args) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                JFrame f = new JFrame();
                sgPlot sg = new sgPlot("test",new Dimension(200,200));
                f.add(sg);
                f.setVisible(true);
                f.pack();
                f.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
            }
        });
    }


    /** Creates new form SGTPlot */
    public sgPlot(String title, Dimension size) {
        initComponents();
        data = new sgData();
        data.addPropertyChangeListener(this);
        init(title,size);
        this.addComponentListener(this);
    }

    public sgData getDataModel() {
        return data;
    }

    private void init(String t, Dimension size) {
        pane_ = new JPane(t, size);
        pane_.setBatch(true);
        pane_.setLayout(new BorderLayout(0,0));
        pane_.setBackground(Color.WHITE);
        pane_.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        
        /*
         * xsize, ysize are the width and height in physical units
         * of the Layer graphics region.
         *
         * xstart, xend are the start and end points for the X axis
         * ystart, yend are the start and end points for the Y axis
         */
        double xsize = 8.0;
        double xstart = 0.6;
        double xend = 7.5;
        double ysize = 5.0;
        double ystart = 0.6;
        double yend = 4.75;
        /*
         * Create the layer and add it to the Pane.
         */
        CartesianGraph graph;
        /*
         * Get x and y ranges from data source.
         */
        SoTRange.Double xrange = (SoTRange.Double) data.getXRange();
        SoTRange.Double yrange = (SoTRange.Double) data.getYRange();

        xt_ = new LinearTransform(xstart, xend, xrange.start, xrange.end);
        yt_ = new LinearTransform(ystart, yend, yrange.start, yrange.end);

        layer_ = new Layer("Layer 1", new Dimension2D(xsize, ysize));
        pane_.add(layer_,BorderLayout.CENTER);

        SGLabel title = new SGLabel("title",
                    t,
                    new Point2D.Double((xstart+xend)/2.0,
                               ysize-0.05));
        title.setAlign(SGLabel.TOP, SGLabel.CENTER);
        title.setFont(new Font("Serif", Font.PLAIN, 14));
        title.setHeightP(0.25);
        title.setColor(Color.blue.darker());
        layer_.addChild(title);
        /*
         * Create a CartesianGraph and set transforms.
         */
        graph = new CartesianGraph("Time Graph");
        layer_.setGraph(graph);
        graph.setXTransform(xt_);
        graph.setYTransform(yt_);
        /*
         * Create the bottom axis, set its range in user units
         * and its origin. Add the axis to the graph.
         */
        SoTPoint origin = new SoTPoint(xrange.start, yrange.start);
        xbot_ = new PlainAxis("Botton Axis");
        xbot_.setRangeU(xrange);
        xbot_.setLocationU(origin);
        Font xbfont = new Font("Serif", Font.PLAIN, 24);
        SGLabel xLabel = new SGLabel("xLegend","Seconds",
                new Point2D.Double((xstart+xend)/2.0, ysize-0.05));
        xbot_.setTitle(xLabel);
        xbot_.setLabelFont(xbfont);
        xLabel.setFont(xbfont);
        graph.addXAxis(xbot_);
        
        yleft_ = new PlainAxis("Left Axis");
        yleft_.setRangeU(yrange);
        yleft_.setLocationU(origin);
        yleft_.setLabelFont(xbfont);
        graph.addYAxis(yleft_);

        LineAttribute attr = new LineAttribute();
        graph.setData((SGTData) data,attr);

        add(pane_, BorderLayout.CENTER);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        setName("Form"); // NOI18N
        setLayout(new java.awt.BorderLayout());
    }// </editor-fold>//GEN-END:initComponents

    private void resetRange() {
    /*
     * A change in the range has occured. Get new range
     * and set transforms, axes, and origin appropriately.
     */
    pane_.setBatch(true);
    SoTRange.Double xrange = (SoTRange.Double)data.getXRange();
    SoTRange.Double yrange = (SoTRange.Double)data.getYRange();
    SoTPoint origin = new SoTPoint(xrange.start, yrange.start);
    xt_.setRangeU(xrange);
    yt_.setRangeU(yrange);
    xbot_.setRangeU(xrange);
    xbot_.setLocationU(origin);
    yleft_.setRangeU(yrange);
    yleft_.setLocationU(origin);
    pane_.setBatch(false);
  }
  public void propertyChange(PropertyChangeEvent evt) {
    /**
     * dataModified property is handled by CartesianGraph
     * only need to look for rangeModified here to make sure
     * range is properly updated
     */
    if("rangeModified".equals(evt.getPropertyName())) {
      resetRange();
    }
  }

    public void componentResized(ComponentEvent e) {
        pane_.setSize(getSize());
    }

    public void componentMoved(ComponentEvent e) {}

    public void componentShown(ComponentEvent e) {}

    public void componentHidden(ComponentEvent e) {}



    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

}
