/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package phalgui.Node.Waveform;

import java.io.File;
import java.util.Vector;
import phalControl.commandManager.ObjectInfo;
import phalControl.commandManager.ProcInfo;
import phalgui.Utils.ReadWriteTextFile;

/**
 *
 * @author ismael
 */
class WaveformParser {

    private File file;

    public WaveformParser(File file) {
        this.file = file;
    }
    public static String objNameField = "obj_name=";
    public static String execNameField = "exe_name=";
    public static String procField = "proc=";
    public static String outputItf = "outputs";
    public static String inputItf = "inputs";
    public static String itfNameField = "name=";
    public static String remoteitfNameField = "remote_itf=";
    public static String remoteobjNameField = "remote_obj=";
    public static String bwField = "bw=";

    ObjectInfo[] parse() {
        String contents = ReadWriteTextFile.getContents(file);
        Vector execVect = new Vector<ObjectInfo>();

        int i = 0;
        do {
            i = contents.indexOf(objNameField, i);
            if (i == -1) {
                break;
            }

            ObjectInfo p = new ObjectInfo();
            execVect.add(p);
            i += objNameField.length();
            p.name = contents.substring(i, contents.indexOf("\n", i));

            i = contents.indexOf(execNameField, i);
            i += execNameField.length();
            p.exeName = contents.substring(i, contents.indexOf("\n", i));

            i = contents.indexOf(procField, i);
            i += procField.length();
            p.C = new Double(contents.substring(i, contents.indexOf("\n", i)));

            if (contents.indexOf(outputItf, i) < contents.indexOf(objNameField, i)) {
                ObjectInfo.itf itf = p.additf();

                i = contents.indexOf(itfNameField, i);
                i += itfNameField.length();
                itf.name = contents.substring(i, contents.indexOf("\n", i));

                i = contents.indexOf(remoteitfNameField, i);
                i += remoteitfNameField.length();
                itf.remoteName = contents.substring(i, contents.indexOf("\n", i));

                i = contents.indexOf(remoteobjNameField, i);
                i += remoteobjNameField.length();
                itf.remoteObjectName = contents.substring(i, contents.indexOf("\n", i));

                i = contents.indexOf(bwField, i);
                i += bwField.length();
                itf.BW = new Double(contents.substring(i, contents.indexOf("\n", i)));

                itf.mode = ObjectInfo.itfMode.OUT.num;
            }            

        } while (i < contents.length());

        if (i>0 && i<contents.length()) {
            System.out.println("Caution. Some contents where not readed (" + i + "<" + contents.length() + ")");
        }

        ObjectInfo execs[] = (ObjectInfo[]) execVect.toArray(new ObjectInfo[execVect.size()]);

        for (int wi = 0; wi < execs.length; wi++) {
            for (int wj = 0; wj < execs[wi].itfs.length; wj++) {
                for (int ri = 0; ri < execs.length; ri++) {
                    if (execs[ri].name.equals(execs[wi].itfs[wj].remoteObjectName)) {
                        ObjectInfo.itf itf = execs[ri].additf();
                        itf.name = execs[wi].itfs[wj].remoteName;
                        itf.BW = execs[wi].itfs[wj].BW;
                        execs[wi].itfs[wj].remoteExec = execs[ri];
                        execs[wi].itfs[wj].remoteItf = itf;
                        itf.remoteExec = execs[wi];
                        itf.remoteItf = execs[wi].itfs[wj];
                        itf.fifo_usage = execs[wi].itfs[wj].fifo_usage;
                        itf.mode = ObjectInfo.itfMode.IN.num;
                    }
                }
            }

        }
        return execs;
    }
}
