/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalgui.Node.Waveform;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JToggleButton;
import javax.swing.SwingWorker;
import phalControl.PlatformControl.WaveformNotFoundException;
import phalControl.commandManager.ObjectInfo;
import phalControl.commandManager.ProcInfo;
import phalControl.commandManager.commandManager.ErrorInCommandException;
import phalgui.Control.MainControl;
import phalgui.Control.MainControl.PlatformNotConnected;
import phalgui.Node.Executable.ExecutableGraphic;
import phalgui.Utils.Graphics.GraphicsPanel;

/**
 *
 * @author ismael
 */
class WaveformView extends GraphicsPanel {
    private MainControl main;
    private String waveformName;
    private ExecutableGraphic[] execg;
    private JComboBox selectView;
    private JToggleButton showMappingButton;
    private boolean showMapping;

    public WaveformView(MainControl main, String waveformName){
        super();
        this.main = main;

        JPanel buttonPanel = new JPanel();
        JButton restore = new JButton("Restore");
        restore.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent arg0) {
                restoreSizes();
                drawAll();
            }
        });
        buttonPanel.add(restore);
        JButton refresh = new JButton ("Refresh");
        refresh.addActionListener (new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                refreshButtonActionPerformed(e);
            }

        });
        buttonPanel.add (refresh);
        buttonPanel.add(new JLabel("Select data to display:"));
        selectView = new JComboBox();
        for (int i=0;i<ExecutableGraphic.ViewInfo.values().length;i++) {
            selectView.addItem(ExecutableGraphic.ViewInfo.values()[i]);
        }
        selectView.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                selectView();
            }
        });
        selectView.setSelectedItem(ExecutableGraphic.ViewInfo.USECMAX);
        buttonPanel.add(selectView);
        add(buttonPanel, BorderLayout.NORTH);

        showMappingButton = new JToggleButton("Show Mapping");
        showMapping=false;
        showMappingButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent arg0) {
               refreshButtonActionPerformed(arg0);
            }
        });
        buttonPanel.add(showMappingButton);
        this.waveformName = waveformName;
        
    }

    public void readExecs(ObjectInfo[] rexecs) throws PlatformNotConnected, WaveformNotFoundException, ErrorInCommandException  {
        ObjectInfo[] execs = new ObjectInfo[rexecs.length];
        for (int i=0;i<execs.length;i++) {
            execs[execs.length-i-1] = rexecs[i];
        }
        execg = new ExecutableGraphic[execs.length];
        for (int i=0;i<execs.length;i++) {
            double x = 160 * ((i) % 8)+50;
            double y = 160 * (i / 8)+50;
            execg[i] = new ExecutableGraphic(main, execs[i], x, y,showMappingButton);
        }
        add(execg);

        for (int i = 0; i < execg.length; i++) {
            for (int j = 0; j < execg.length; j++) {
                if (execg[i].connectsWith(execg[j])) {
                    execg[i].connectWith(execg[j]);
                }
            }
            execg[i].udpateLines();
        }
    }

    private void selectView() {
        for (int i=0;i<getObjects().length;i++) {
           ((ExecutableGraphic) getObjects()[i]).selectView((ExecutableGraphic.ViewInfo) selectView.getSelectedItem());
        }
        getScene().refresh();
    }

    private void refreshButtonActionPerformed(ActionEvent e) {
        SwingWorker w = new SwingWorker<Void,Void>() {

            @Override
            protected Void doInBackground() throws Exception {
                main.getPlatform().refresh();
                return null;
            }
            @Override
            protected void done() {
                try {

                    ObjectInfo[] execs = main.getPlatform().getWaveform(waveformName).getExecInfo();
                    Object[] pg = (Object[]) getObjects();
                    for (int i=0;i<execs.length;i++) {
                        boolean found=false;
                        for (int j=0;j<pg.length;j++) {
                            if (pg[j].toString().equals(String.valueOf(execs[i].name))) {
                                ((ExecutableGraphic) pg[j]).updateInfo(execs[i]);
                                found=true;
                            }
                        }
                        /*if (!found) {
                            ExecutableGraphic p = new ExecutableGraphic(main, execs[i], ((ExecutableGraphic) pg[pg.length-1]).getX()+400, ((ExecutableGraphic) pg[pg.length-1]).getY()+400);
                            add(p);
                        }*/
                    }
                    /*for (int i = 0; i < pg.length; i++) {
                        for (int j = 0; j < pg.length; j++) {
                            if (((ExecutableGraphic) pg[i]).connectsWith(((ExecutableGraphic) pg[j]))) {
                                ((ExecutableGraphic) pg[i]).connectWith(((ExecutableGraphic) pg[j]));
                            }
                        }
                    }*/
                } catch (WaveformNotFoundException ex) {
                    Logger.getLogger(WaveformView.class.getName()).log(Level.SEVERE, null, ex);
                } catch (PlatformNotConnected ex) {
                    Logger.getLogger(WaveformView.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        };
        w.execute();
    }

}
