/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package phalgui.Tree;

import javax.swing.tree.MutableTreeNode;
import phalgui.Node.NodeObject;
import java.awt.Component;
import java.awt.datatransfer.Transferable;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeModelEvent;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.tree.ExpandVetoException;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Properties;
import javax.swing.JComponent;
import javax.swing.JTree;
import javax.swing.SwingUtilities;
import javax.swing.TransferHandler;
import javax.swing.event.TreeModelListener;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeWillExpandListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeCellRenderer;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;
import javax.xml.soap.Node;
import phalgui.Node.NodeObject.NodeListener;
import phalgui.Utils.DoubleClick;





/**
 *
 * @author root
 */
public class MainTree extends JTree implements NodeListener,MouseListener,TreeSelectionListener,TreeWillExpandListener {

    NodeObject root;
    private DoubleClick doubleclick = new DoubleClick();
        
    public MainTree(NodeObject root) {
        /** add listener!!! */
        super(root);
        this.root = root;

        root.addNodeListener(this);

        getSelectionModel().setSelectionMode
                (TreeSelectionModel.SINGLE_TREE_SELECTION);
        setShowsRootHandles(true);

        setCellRenderer(new CellRenderer());
        addMouseListener(this);
        addTreeSelectionListener(this);
        addTreeWillExpandListener(this);
        setExpandsSelectedPaths(true);
        setVisible(true);
        setDragEnabled(true);

        setTransferHandler(new TreeTransferHandler(this));
        getModel().addTreeModelListener(new TreeListener(this));

        this.setRowHeight(22);
    }

    public NodeObject findNodeName(String name) {
        return root.findNodeName(name);
    }
   
    public void WriteConfig (Properties props) {
        root.WriteConfig(props);
    }
    
    public void ReadConfig (Properties props) {
        root.ReadConfig(props);
    }

    public NodeObject getRoot() {
        return root;
    }

    public void Refresh() {
        this.updateUI();
        repaint();
        revalidate();
    }

    public void mouseReleased(MouseEvent e) {}
    
    public void mouseClicked(final MouseEvent e) {
        
        TreePath selPath = getPathForLocation(e.getX(), e.getY());
        if (selPath == null) {
            return;
        }
        setSelectionPath(selPath);
                
        final NodeObject entry = (NodeObject) selPath.getLastPathComponent();
        
        if (e.getButton() == MouseEvent.BUTTON3) {
            entry.RightClick(e);
            expandPath(selPath);
        } else {
            if (e.getClickCount() < 2) {
                entry.LeftClick(e);  
                expandPath(selPath);
            } else {
                SwingUtilities.invokeLater(new Runnable() {
                    public void run() {
                        entry.DoubleClick(e);
                    }
                });
            }
        }
    }

    public NodeObject getSelectedNode() {
        TreePath path = getSelectionPath();
        if (path == null)
            return null;
        NodeObject entry = (NodeObject) path.getLastPathComponent();
        if (entry == null)
            return null;
        return entry;
    }

    public void valueChanged(TreeSelectionEvent e) {
        Object obj = getSelectedNode();
        if (obj instanceof NodeObject) {
            ((NodeObject) obj).Selected(e);
        }
    }

    public void treeWillExpand(TreeExpansionEvent e) throws ExpandVetoException {

    }


    
    public void treeWillCollapse(TreeExpansionEvent event) throws ExpandVetoException {}
    
    public void treeStructureChanged(TreeModelEvent e) {}
    
    public void mousePressed(MouseEvent e) { }

    public void mouseEntered(MouseEvent e) {}

    public void mouseExited(MouseEvent e) { }

    public void nodeAdded(MutableTreeNode node) {

        Refresh();
    }

}
class CellRenderer implements TreeCellRenderer {
  
  DefaultTreeCellRenderer defaultRenderer = new DefaultTreeCellRenderer();
    
  public CellRenderer() {
     
  }

    public Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus) {
        
        Component returnValue = null;

        if ((value != null) && (value instanceof NodeObject)) {
            returnValue = ((NodeObject) value).getCellComponent(tree, value, selected, expanded, leaf, row, hasFocus);
        }
        if (returnValue == null) {
          returnValue = defaultRenderer.getTreeCellRendererComponent(tree,
              value, selected, expanded, leaf, row, hasFocus);
        }
        return returnValue;
    }
}

class TreeTransferHandler extends TransferHandler {

    MainTree tree;
    public TreeTransferHandler(MainTree tree) {
        this.tree = tree;
    }

    @Override
    protected Transferable createTransferable(JComponent c) {
      return ((NodeObject) tree.getSelectedNode()).createTransferable(c);
    }

    @Override
    public int getSourceActions(JComponent c) {
        return TransferHandler.COPY_OR_MOVE;
    }

    @Override
    protected void exportDone(JComponent c, Transferable data, int action) {
        ((NodeObject) tree.getSelectedNode()).exportDone(c,data,action);
    }
}

class TreeListener implements TreeModelListener {

    MainTree tree;
    public TreeListener(MainTree tree) {
       this.tree = tree;
    }
    public void treeNodesChanged(TreeModelEvent e) {
        DefaultMutableTreeNode node;
        node = (DefaultMutableTreeNode)(e.getTreePath().getLastPathComponent());

        int index = e.getChildIndices()[0];
        node = (DefaultMutableTreeNode)(node.getChildAt(index));
        tree.expandPath(new TreePath(node.getPath()));

        tree.Refresh();
    }

    public void treeNodesInserted(TreeModelEvent e) {
        DefaultMutableTreeNode node;
        node = (DefaultMutableTreeNode)(e.getTreePath().getLastPathComponent());

        int index = e.getChildIndices()[0];
        node = (DefaultMutableTreeNode)(node.getChildAt(index));
        //tree.expandPath(new TreePath(node.getPath()));
        //tree.setSelectionPath();

        tree.Refresh();
    }

    public void treeNodesRemoved(TreeModelEvent e) {
        tree.Refresh();
    }

    public void treeStructureChanged(TreeModelEvent e) {
        tree.Refresh();
    }
}


