/*
 * Extension.java
 *
 * Created on 7 de diciembre de 2001, 00:55
 */

package phalgui.Utils.Arrows;


import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/**
 * This class implements the arrows file filter. Filters the files of the directory
 * depending on the extension of them.
 * @author  Santi Oliveras
 * @version 1.0  8/05/2002
 * @see ArrowsFileView
 */
public class ArrowsFilter extends FileFilter {
    
    // ******** public methods *************************************************
    
    /** Accepts all directories and all gif, jpg, tiff, ini, log, graph, pag, dvw files. */
    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }

        String extension = Extension.getExtension(f);
	if (extension != null) {
            if (extension.equals(Extension.TIFF) ||
                extension.equals(Extension.TIF) ||
                extension.equals(Extension.GIF) ||
                extension.equals(Extension.JPEG) ||
                extension.equals(Extension.JPG)||
                extension.equals(Extension.INI)||
                extension.equals(Extension.LOG)||
                extension.equals(Extension.GRAPH)||
                extension.equals(Extension.PAG)||
                extension.equals(Extension.DVW)) {
                    return true;
            } else {
                return false;
            }
    	}

        return false;
    }
    
    /** Returns the description of the filter. ('Arrows Files') */
    public String getDescription() {
        return "Arrows Files";
    }
}
