
/* Extension.java
 *
 * Created on 7 de diciembre de 2001, 00:55
 */

package phalgui.Utils.Arrows;

import java.io.File;

/**
 * This class supports the methods to manage the extension of the  arrows files.
 * @author  Santi Oliveras
 * @version 1.0  8/05/2002
 */
public class Extension {

    // ******** public variables ***********************************************
    
    /** String with the jpeg extension. */
    public final static String JPEG = "jpeg";
    
    /** String with the jpg extension. */
    public final static String JPG = "jpg";
    
    /** String with the gif extension. */
    public final static String GIF = "gif";
    
    /** String with the tiff extension. */
    public final static String TIFF = "tiff";
    
    /** String with the tif extension. */
    public final static String TIF = "tif";
    
    /** String with the ini extension. */
    public final static String INI = "ini";
    
    /** String with the log extension. */
    public final static String LOG = "log";
    
    /** String with the dinamic viewer extension. */
    public final static String DVW = "dvw";
    
    /** String with the graphic extension. */
    public final static String GRAPH = "graph";
    
    /** String with the panels agrupation extension. */
    public final static String PAG = "pag";

    
    // ******** public methods *************************************************
    
    /** Returns a String with the extension of a file.
     * @param f The file to get the extension
     */
    public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        if(ext==null)
            return "";
        return ext;
    }
    
    /** Sets the extension of a file.
     * @param f A file to set the extension
     * @param ext The extension to set
     * @return The file with the new extension
     */
    public static File setExtension(File f,String ext) {
        String name = null;        
        StringParser sp=new StringParser(f.getPath(),false);
        if(sp.hasNextToken('.'))
            name=sp.getNextToken('.')+"."+ext;
        else
            name=sp.getNextToken()+"."+ext;
        return new File(name);
    }
}
