package phalgui.Utils.Arrows;

/**
 * This class supports a dupla struct formed by an integer (milisecond) and a string (value).
 * Is used by the Graphics to save its values in a vector.
 * @author  Santi Oliveras
 * @version 1.0 5/04/2002
 */
public class ValueStamp {
    
    // ******** private variables **********************************************
    
    private double milisec;
    private String value;
    private int id;
    
    
    // ******** constructor ****************************************************
    
    /** Creates new ValueStamp.
     * @param value String with the value at this milisecond
     * @param milisec Integer with the milisecond
     */
    public ValueStamp(String value, double milisec) {
        this.value=value;
        this.milisec=milisec;
    }
    public ValueStamp(String value, double milisec, int id) {
        this.value=value;
        this.milisec=milisec;
        this.id = id;
    }

    public int getId() {
        return id;
    }
    
    
    // ******** public methods *************************************************
    
    /** Returns a String with the value. */
    public String getValue() {
        return value;
    }
    
    /** Returns an Integer with the time in miliseconds */
    public double getTime() {
        return milisec;
    }
    
    /** Returns the value of the ValueStamp. Overrides toString() method in Object class.
     */ 
    public String toString() {
        return value;
    }
    
}

