/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalgui.Utils.DnD;

import java.awt.datatransfer.DataFlavor;
import java.io.FileNotFoundException;
import java.io.Serializable;
import java.util.logging.Level;
import java.util.logging.Logger;
import phalControl.PlatformControl.WaveformNotFoundException;
import phalControl.commandManager.commandManager.ErrorInCommandException;
import phalgui.Control.MainControl.PlatformNotConnected;
import phalgui.Node.Log.LogView;
import phalgui.Node.Processor.ProcessorNode;
import phalgui.Node.Processor.ProcessorView;
import phalgui.Node.Stats.StatView;
import phalgui.Node.Waveform.WaveformDiagram;

/**
 *
 * @author Usuario
 */
public class TransfObject implements Serializable {
    public enum TransfType {
        LOG("logview"),STAT("statview"),PROC("procview"),WAVEDIA("wavediagram");

        private String desc;
        TransfType(String desc) {
            this.desc=desc;
        }
        public String toString() {
            return desc;
        }
        public static TransfType valueOfStr(String desc) {
            for (int i=0;i<TransfType.values().length;i++) {
                if (TransfType.values()[i].desc.equals(desc)) {
                    return TransfType.values()[i];
                }
            }
            return null;
        }
        public static TransfType valueOf(TransfResizePanel object) {
            if (object instanceof LogView) {
                return TransfType.LOG;
            } else if (object instanceof StatView) {
                return TransfType.STAT;
            } else if (object instanceof ProcessorView) {
                return TransfType.PROC;
            } else if (object instanceof WaveformDiagram) {
                return TransfType.WAVEDIA;
            }
            return null;
        }
    }
    public TransfType type;
    public String[] info;
    public TransfObject(TransfResizePanel object) {
       this.type = TransfType.valueOf(object);
       this.info = object.getTransferData();
    }

    public TransfObject(TransfType type, String[] info) {
        this.type = type;
        this.info = info;
    }

    public TransfResizePanel newObject(DataFlavor flavor) {
        if (info == null)
            return null;
        switch(type) {
            case LOG:
                try {
                    return new LogView(info, flavor);
                } catch (FileNotFoundException ex) {
                    Logger.getLogger(TransfObject.class.getName()).log(Level.SEVERE, null, ex);
                    return null;
                }
            case STAT:
                try {
                    return new StatView(info, flavor);
                } catch (FileNotFoundException ex) {
                    Logger.getLogger(TransfObject.class.getName()).log(Level.SEVERE, null, ex);
                } catch (PlatformNotConnected ex) {
                    Logger.getLogger(TransfObject.class.getName()).log(Level.SEVERE, null, ex);
                } catch (WaveformNotFoundException ex) {
                    Logger.getLogger(TransfObject.class.getName()).log(Level.SEVERE, null, ex);
                } catch (ErrorInCommandException ex) {
                    Logger.getLogger(TransfObject.class.getName()).log(Level.SEVERE, null, ex);
                }
            case PROC:
                return new ProcessorView(info);
            case WAVEDIA:
        try {
            return new WaveformDiagram(info);
        } catch (PlatformNotConnected ex) {
            Logger.getLogger(TransfObject.class.getName()).log(Level.SEVERE, null, ex);
        } catch (WaveformNotFoundException ex) {
            Logger.getLogger(TransfObject.class.getName()).log(Level.SEVERE, null, ex);
        }
            default:
                return null;
        }
    }

}
