/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalgui.Utils.DnD;

import java.awt.Cursor;
import java.awt.Point;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.Properties;
import javax.swing.BorderFactory;
import javax.swing.JPanel;

/**
 *
 * @author Usuario
 */
public abstract class TransfResizePanel  extends JPanel implements MouseMotionListener,MouseListener,Transferable {

    private int oldx, oldy, actionType; //integers used to controll the movement
      /** Integer with which indicates the movement state. (the panel is moved) */
    public static final int MOVING_TYPE=0;

    /** Integer which indicated a South East resizing. */
    public static final int RESIZING_SE_TYPE=1;

    /** Integer which indicated a South West resizing. */
    public static final int RESIZING_SW_TYPE=2;

    /** Integer which indicated a North West resizing. */
    public static final int RESIZING_NW_TYPE=3;

    /** Integer which indicated a North East resizing. */
    public static final int RESIZING_NE_TYPE=4;
    private JPanel panel;

    final public static DataFlavor PANEL =
    new DataFlavor(TransfResizePanel.class, "Panel");
    final public static DataFlavor OBJECT =
    new DataFlavor(TransfResizePanel.class, "Object");
  
    private DataFlavor[] flavors = {PANEL};

    
    public void setPanel(JPanel panel) {
        this.panel = panel;
        this.addMouseListener(this);
        this.addMouseMotionListener(this);
    }

    public void unsetPanel() {
        this.removeMouseListener(this);
        this.removeMouseMotionListener(this);
    }
  

    public DataFlavor[] getTransferDataFlavors() {
        return flavors;
    }

    public boolean isDataFlavorSupported(DataFlavor flavor) {
        for (int i=0;i<getTransferDataFlavors().length;i++) {
            if (getTransferDataFlavors()[i].equals(flavor)) {
                return true;
            }
        }
        return false;
    }

    public Object getTransferData(DataFlavor flavor) {
        return new TransfObject(this);
    }

    public abstract String[] getTransferData();
    public abstract void Close();

    public abstract void refreshPanel();

    public void mousePressed(java.awt.event.MouseEvent evt) {

        oldx=evt.getX();
        oldy=evt.getY();
        if(evt.getX()>getWidth()-10 && evt.getY()>getHeight()-10)
            actionType=RESIZING_SE_TYPE;
        else if(evt.getX()<10 && evt.getY()>getHeight()-10)
            actionType=RESIZING_SW_TYPE;
        else if(evt.getX()<10 && evt.getY()<10)
            actionType=RESIZING_NW_TYPE;
        else if(evt.getX()>getWidth()-10 && evt.getY()<10)
            actionType=RESIZING_NE_TYPE;
        else
            actionType=MOVING_TYPE;
    }


    /** Sets the default cursor when the mouse exits the panel. */
    public void mouseExited(java.awt.event.MouseEvent evt) {
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }


    /** Sets the correspondent cursor depending on the cursor situation,
     * when the mouse is moved. */
    public void mouseMoved(java.awt.event.MouseEvent evt) {
        if(evt.getX()>getWidth()-10 && evt.getY()>getHeight()-10)
            setCursor(new Cursor(Cursor.SE_RESIZE_CURSOR));
        else if(evt.getX()<10 && evt.getY()>getHeight()-10)
            setCursor(new Cursor(Cursor.SW_RESIZE_CURSOR));
        else if(evt.getX()<10 && evt.getY()<10)
            setCursor(new Cursor(Cursor.NW_RESIZE_CURSOR));
        else if(evt.getX()>getWidth()-10 && evt.getY()<10)
            setCursor(new Cursor(Cursor.NE_RESIZE_CURSOR));
        else
            setCursor(new Cursor(Cursor.HAND_CURSOR));
    }

    /** Depending on the actionType the bounds of the panel are changed when
     * the mouse is dragged. */
    public void mouseDragged(java.awt.event.MouseEvent evt) {
        if(actionType==RESIZING_SE_TYPE){
            if(getX()+evt.getX()+1>panel.getWidth() | getY()+evt.getY()+1>panel.getHeight())
                return;
            setBounds(getX(),getY(),evt.getX()+1,evt.getY()+1);
            setCursor(new Cursor(Cursor.SE_RESIZE_CURSOR));
            validate();
            return;
        }
        if(actionType==RESIZING_SW_TYPE){
            if(evt.getX()+getX()-oldx-5<0 | getY()+evt.getY()+1>panel.getHeight())
                return;
            setBounds(evt.getX()+getX()-oldx-5,getY(),getWidth()-evt.getX()+oldx+5,evt.getY()+1);
            setCursor(new Cursor(Cursor.SW_RESIZE_CURSOR));
            validate();
            return;
        }
        if(actionType==RESIZING_NW_TYPE){
            if(evt.getX()+getX()-oldx-5<0 | evt.getY()+getY()-oldy-5<0)
                return;
            setBounds(evt.getX()+getX()-oldx-5,evt.getY()+getY()-oldy-5,getWidth()-evt.getX()+oldx+5,getHeight()-evt.getY()+oldy+5);
            setCursor(new Cursor(Cursor.NW_RESIZE_CURSOR));
            validate();
            return;
        }
        if(actionType==RESIZING_NE_TYPE){
            if(getX()+evt.getX()+1>panel.getWidth() | evt.getY()+getY()-oldy-5<0)
                return;
            setBounds(getX(),evt.getY()+getY()-oldy-5,evt.getX()+1,getHeight()-evt.getY()+oldy+5);

            setCursor(new Cursor(Cursor.NE_RESIZE_CURSOR));
            validate();
            return;
        }
        Point p=new Point(evt.getX()+getX()-oldx,evt.getY()+getY()-oldy);
        if(p.x+getWidth()>panel.getWidth())
            p.x=panel.getWidth()-getWidth();
        if(p.y+getHeight()>panel.getHeight())
            p.y=panel.getHeight()-getHeight();
        p.x=Math.max(p.x,0);
        p.y=Math.max(p.y,0);
        setBounds(p.x,p.y,getWidth(),getHeight());
        validate();
    }

     public void mouseClicked(MouseEvent e) {}

    public void mouseReleased(MouseEvent e) { }

    public void mouseEntered(MouseEvent e) {}

}


