/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalgui.Utils;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;
import phalgui.Utils.iFileReader.LastLinesListener;
import phalgui.Utils.iFileReader.TextUpdateListener;

/**
 *
 * @author Usuario
 */
public class FileToTextArea  {

    JTextArea output;
    boolean running;
    long current_pos;
    private iFileReader reader;
    
    public FileToTextArea(File file, JTextArea output) throws FileNotFoundException {
        this(file,output,false);
    }

    public FileToTextArea(final File file, final JTextArea output, boolean SeekToEnd) throws FileNotFoundException {
        try {
            this.output = output;
            running = true;
            reader = new iFileReader(file);
            if (SeekToEnd) {
                current_pos = reader.getLength();
            }
            //output.append(reader.readlast(1000));
            reader.seekToEnd();
            reader.setLastLinesListener(new LastLinesListener() {

                public void TextUpdated() {
                    try {
                        long new_pos = reader.getLength();
                        output.append(reader.read(current_pos, new_pos));
                        current_pos = new_pos;
                    } catch (IOException ex) {
                        Logger.getLogger(FileToTextArea.class.getName()).log(Level.SEVERE, null, ex);
                        output.append("Error readeing file" + file.getName());
                    }
                }

                public void LastLines(String[] lines) {
                    for (int i=0;i<lines.length;i++) {
                        if (!lines[i].endsWith("\\n")) {
                            output.append(lines[i] + "\n");
                        } else {
                            output.append(lines[i]);
                        }
                    }
                        
                }
        });
        } catch (IOException ex) {
            Logger.getLogger(FileToTextArea.class.getName()).log(Level.SEVERE, null, ex);
            output.append("Error reading file " + file.getName());
        }
    }

    public void stop() {
        reader.stopReader();
    }

}
