/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalgui.Utils.Graphics;

import java.awt.Color;
import no.geosoft.cc.geometry.Geometry;
import no.geosoft.cc.graphics.GObject;
import no.geosoft.cc.graphics.GSegment;
import no.geosoft.cc.graphics.GStyle;
import no.geosoft.cc.graphics.GTransformer;

/**
 *
 * @author ismael
 */
public class GPort {
    private final int portIdx;

    public static interface PosInterface {
        public double getPortX(int idx);
        public double getPortY(int idx);
    }

    private double x0,y1;
    private double y0,x1;
    private int size;
    private Mode mode;
    private GSegment upLine,downLine;
    private double x;
    private double y;
    private GObject parent;
    public enum Mode{LEFT,RIGHT, POINT};
    PosInterface parentItf;
    public GPort(GObject parent, int portIdx, int size, Mode mode) {
        this.parent = parent;
        this.parentItf = (PosInterface) parent;
        this.x=parentItf.getPortX(portIdx);
        this.y=parentItf.getPortY(portIdx);
        this.size=size;
        this.mode=mode;
        this.portIdx=portIdx;
        upLine = new GSegment();
        parent.addSegment(upLine);
        downLine = new GSegment();
        parent.addSegment(downLine);
        updatePos();
    }

    public void updatePos() {
         this.x=parentItf.getPortX(portIdx);
        this.y=parentItf.getPortY(portIdx);
       switch(mode) {
            case LEFT:
                x0=x-size;
                y0=y-size;
                x1=x-size;
                y1=y+size;
                break;
            case RIGHT:
                x0=x+size;
                y0=y-size;
                x1=x+size;
                y1=y+size;
                break;
        }
    }

    public double getX() {
        return x;
    }

    public double getY() {
        return y;
    }

    public void draw() {
        updatePos();
        if (mode == Mode.POINT) {
            upLine.setGeometryXy(Geometry.createRectangle(x-size/4, y-size, size/2,2*size));
            GStyle style = new GStyle();
            style.setBackgroundColor(Color.BLACK);
            upLine.setStyle(style);
        } else {
            upLine.setGeometry(x,y,x0,y0);
            downLine.setGeometry(x,y,x1,y1);
        }
    }
    public void translate (GSegment segment, int dx, int dy) {
      GTransformer transformer = parent.getTransformer();
      updatePos();
      double[] dw0 = transformer.deviceToWorld (0,  0);
      double[] dw1 = transformer.deviceToWorld (dx, dy);
      x += dw1[0] - dw0[0];
      y += dw1[1] - dw0[1];
      x0 += dw1[0] - dw0[0];
      y0 += dw1[1] - dw0[1];
      x1 += dw1[0] - dw0[0];
      y1 += dw1[1] - dw0[1];
    }

}
