/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalgui.Utils.Graphics;

import no.geosoft.cc.graphics.GObject;
import no.geosoft.cc.graphics.GPosition;
import no.geosoft.cc.graphics.GSegment;
import no.geosoft.cc.graphics.GStyle;
import no.geosoft.cc.graphics.GText;

/**
 *
 * @author ismael
 */
public class GRectLine {
    private direction mode;
    private GSegment lines[];
    private double x[];
    private double y[];
    private GObject parent;
    private double minx;
    private double miny;
    private itfBlock remote;
    private itfBlock local;
    int local_idx, remote_idx;

    public enum direction {LEFT,RIGHT};

    public interface itfBlock {
        public double getPortX(int idx);
        public double getPortY(int idx);
    }

    public boolean equals(itfBlock parent, itfBlock remote, int local_idx, int remote_idx) {
        return this.parent.equals(parent)
                && this.remote.equals(remote)
                && this.local_idx == local_idx
                && this.remote_idx == remote_idx;
    }

    public GRectLine(String label, itfBlock parent, itfBlock remote, int local_idx, int remote_idx, double minx, double miny) {
        this.parent = (GObject) parent;
        this.local = parent;
        this.remote = remote;
        this.minx = minx;
        this.miny = miny;
        this.local_idx = local_idx;
        this.remote_idx = remote_idx;

        lines = new GSegment[5];
        x = new double[lines.length+1];
        y = new double[lines.length+1];

        for (int i=0;i<lines.length;i++) {
            lines[i] = new GSegment();
            GStyle s = new GStyle();
            s.setLineWidth(1);
            lines[i].setStyle(s);
            this.parent.addSegment(lines[i]);
        }
        if (label!=null)
            setText(label);
    }
    
    public int getLocalIdx() {
        return local_idx;
    }

    public void setText(String label) {
        lines[0].setText(new GText(label, GPosition.TOP | GPosition.MIDDLE));
    }

    public void setStyle(GStyle style) {
        for (int i=0;i<lines.length;i++) {
            lines[i].setStyle(style);
        }
    }

    public void draw() {
        int n;

        x[0] = local.getPortX(local_idx);
        y[0] = local.getPortY(local_idx);
        x[1] = x[0]+minx;
        y[1] = y[0];
        if (remote.getPortX(remote_idx)-minx<local.getPortX(local_idx)) {
            x[2] = x[1];
            if (remote.getPortY(remote_idx)<local.getPortY(local_idx)) {
                y[2] = remote.getPortY(remote_idx)+miny;
            } else {
                y[2] = remote.getPortY(remote_idx)-miny;
            }
            x[3] = remote.getPortX(remote_idx)-minx/2;
            y[3] = y[2];
            x[4] = x[3];
            y[4] = remote.getPortY(remote_idx);
            n=5;
        } else {
            x[2] = x[1];
            y[2] = remote.getPortY(remote_idx);
            n=3;
        }
        x[n] = remote.getPortX(remote_idx);
        y[n] = remote.getPortY(remote_idx);
        for (int i=0;i<n;i++) {
            lines[i].setGeometry(x[i],y[i],x[i+1],y[i+1]);
        }
        for (int i=n;i<lines.length;i++) {
            lines[i].setGeometry(0, 0);
        }
    }
}
