/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package phalgui.Utils.Graphics;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JSeparator;
import no.geosoft.cc.graphics.GInteraction;
import no.geosoft.cc.graphics.GObject;
import no.geosoft.cc.graphics.GScene;
import no.geosoft.cc.graphics.GSegment;
import no.geosoft.cc.graphics.GStyle;
import no.geosoft.cc.graphics.GWindow;
import phalgui.Node.Processor.ProcessorGraphic;

/**
 *
 * @author ismael
 */
public class GraphicsPanel extends JPanel implements GInteraction {

    private GScene scene_;

    public GraphicsPanel() {
        super();

        setLayout(new BorderLayout());

        // Create the graphic canvas
        GWindow window = new GWindow();
        add(window.getCanvas(), BorderLayout.CENTER);

        // Create scene with default viewport and world extent settings
        scene_ = new GScene(window, "Scene");

        double w0[] = {0.0, 1200.0, 0.0};
        double w1[] = {1400.0, 1200.0, 0.0};
        double w2[] = {0.0, 0.0, 0.0};
        scene_.setWorldExtent(w0, w1, w2);

        GStyle style = new GStyle();
        style.setForegroundColor(new Color(0, 0, 0));
        style.setBackgroundColor(new Color(255, 255, 255));
        style.setFont(new Font("Dialog", Font.BOLD, 14));
        scene_.setStyle(style);

        window.startInteraction(this);
    }
    
    Vector objects = new Vector<GraphicsObject>();



    public void drawAll() {
        for (int i = 0; i < objects.size(); i++) {
            ((GObject) objects.get(i)).draw();
        }
    }

    public void add(GraphicsObject obj) {
        this.add(new GraphicsObject[] {obj});
    }

    public void add(GraphicsObject obj[]) {
        for (int i=0;i<obj.length;i++) {
            scene_.add(obj[i]);
            objects.add(obj[i]);
        }
    }


    public void restoreSizes() {
        GraphicsObject obj[] = getObjects();
        for (int i=0;i<obj.length;i++) {
            double x = 160 * ((i) % 8)+50;
            double y = 160 * (i / 8)+50;
            obj[i].setPos(x, y);
        }
    }


    public GraphicsObject[] getObjects() {
        return (GraphicsObject[]) objects.toArray(new GraphicsObject[objects.size()]);
    }

    private GSegment interactionSegment_;
    private int x0_,  y0_;

    // Move interaction
    public void event(GScene scene, int event, int x, int y) {

        switch (event) {
            case GWindow.BUTTON1_DOWN:
                interactionSegment_ = scene.findSegment(x, y);
                x0_ = x;
                y0_ = y;
                break;

            case GWindow.BUTTON1_DRAG:
                int dx = x - x0_;
                int dy = y - y0_;
                if (interactionSegment_ != null) {
                    GraphicsObject object = (GraphicsObject) interactionSegment_.getOwner();
                    object.translate(interactionSegment_, dx, dy);
                    scene.refresh();
                    drawAll();
                }
                x0_ = x;
                y0_ = y;
                break;

            case GWindow.BUTTON1_UP:
                if (interactionSegment_ != null) {
                    for (int i=0;i<getObjects().length;i++) {
                        getObjects()[i].setSelected(false);
                    }
                    GraphicsObject o = (GraphicsObject) interactionSegment_.getOwner();
                    o.setSelected(true);
                    o.draw();
                    scene.refresh();
                }
                break;
            
        }
    }
    public GScene getScene() {
        return scene_;
    }
}
