/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package phalgui.Utils;

import java.awt.Component;
import java.util.ArrayList;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableCellRenderer;

/**
 *
 * @author Usuario
 */
public class NormalTableModel extends AbstractTableModel {

    private String[] columnNames;
    private ArrayList[] data;

    public NormalTableModel(String[] columns) {
        super();
        this.columnNames = columns;
        data = new ArrayList[columns.length];
        for (int i=0;i<columns.length;i++)
            data[i] = new ArrayList();
    }

    public int getColumnCount() {
        return columnNames.length;
    }

    public int getRowCount() {
        return data[0].size();
    }

    @Override
    public String getColumnName(int col) {
        return columnNames[col];
    }

    public Object getValueAt(int row, int col) {
        return data[col].get(row);
    }

    @Override
    public boolean isCellEditable(int row, int col) {
        return false;
    }

 @Override
    public void setValueAt(Object value, int row, int col) {
        data[col].set(row, value);
        fireTableCellUpdated(row, col);
    }
    public void clearRows() {
        int i;
        for (i=0;i<getColumnCount();i++) {
            data[i].clear();
        }
    }
    public void addRow(Object value[]) {
        int i;
        for (i=0;i<getColumnCount();i++) {
            data[i].add(value[i]);
        }
    }
}


