/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package phalgui.Utils;

import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;


/**
 *
 * @author Usuario
 */
public class PanelTableModel extends AbstractTableModel  {

    private ArrayList objects = new ArrayList();
    Object defaultObject;

    int nof_rows,nof_cols;
    public PanelTableModel(Object defaultObject) {
        super();
        this.nof_rows = 1;
        this.nof_cols = 1;
        this.defaultObject = defaultObject;
    }

    public int getColumnCount() {
        return nof_cols;
    }

    public int getRowCount() {
        return nof_rows;
    }

    public int indexOf(int row, int col) {
        return row*(nof_cols)+col;
    }

    @Override
    public String getColumnName(int col) {
        return "";
    }

    public Object getValueAt(int row, int col) {
        if (indexOf(row,col) < objects.size()) {
            return objects.get(indexOf(row,col));
        } else {
            //((PanelWithText) defaultObject).setText(row + ":" + col + "=" + indexOf(row,col) + ":" + nof_elems);
            return defaultObject;
        }
    }

    public void removeObjectAt(int index) {
        objects.remove(index);
        acomodateElems();
    }

    public void removeObject(int row, int col) {
        if (indexOf(row,col) < objects.size()) {
            removeObjectAt(indexOf(row,col));
        }
    }

    @Override
    public void setValueAt(Object value, int row, int col) {
        objects.set(indexOf(row,col), value);
        fireTableCellUpdated(row, col);
    }

    public void addObject(Object value, int row, int col) {
        if (indexOf(row,col) < objects.size()) {
            objects.add(indexOf(row,col), value);
        } else {
            objects.add(value);
        }
        fireTableCellUpdated(row, col);
        acomodateElems();
    }

    @Override
    public boolean isCellEditable(int row, int col) {
        return false;
    }

    private void acomodateElems() {
        if (objects.size() == 0) {
            nof_rows = 1;
            nof_cols = 1;
        } else {
            nof_cols = ((Double) Math.ceil(Math.sqrt(objects.size()))).intValue();
            nof_rows = ((Double) Math.ceil(new Integer(objects.size()).doubleValue()/nof_cols)).intValue();
        }
        fireTableStructureChanged();

    }
}

